


      SUBROUTINE BAND(A,AT,B,JPT,IN,IBND)
C        SOLVES MATRIX EQUATION FOR HEAD CHANGE VECTOR, B, BY USING
C        TRIANGULAR DECOMPOSITION
      DIMENSION A(1),AT(1),B(1)
      DIMENSION JPT(1),IN(1)
      COMMON/NO/NELS,NNDS,NSTEPS,NPER,NZNS,NWELS,NQBND,NHDS,NEQ,MBWC,MBW
C *** DEFINE INDICES ***
      N=NNDS-NHDS
      MR=MBWC*N+1
      NR=IBND*(N-IBND)+(IBND*(IBND+1))/2
      IF(MR.GT.NR) NR=MR-1
      MBM1=MBWC-1
      NP=MBM1*NEQ
      NN=NEQ+1
      IBM1=IBND-1
C *** TRANSFORM CONDENSED COEFFICIENT MATRIX, A, INTO ROTATED
C     BAND-MATRIX, A ***
      DO 110 I=1,NEQ
      NP=NP-MBM1
      NN=NN-1
      K=IN(NN)
      IF(K.LT.0) GO TO 110
      IRBW=MIN0(IBND,N-K+1)
      DO 90 J=1,IRBW
   90 AT(J)=0.
      MR=MR-MBWC
      IF(A(MR).GT.1.E-20) GO TO 93
      A(MR)=1.E30
      B(K)=0.
   93 AT(1)=A(MR)
      DO 100 J=1,MBM1
      L=JPT(NP+J)
      M=IN(L)
      IF(M) 100,103,95
   95 AT(M-K+1)=A(MR+J)
  100 CONTINUE
  103 NR=NR-IRBW
      DO 105 J=1,IRBW
  105 A(NR+J)=AT(J)
  110 CONTINUE
C *** FACTOR A INTO PRODUCT OF UPPER TRIANGULAR, DIAGONAL, AND LOWER
C     TRIANGULAR MATRICES, ALL KEPT IN A ***
      NM1=N-1
      ID=NR+1
      DO 140 I=1,NM1
      C1=1./A(ID)
      LD=ID
      L=I
      IRBW=MIN0(IBM1,N-I)
      DO 130 J=1,IRBW
      L=L+1
      LD=LD+MIN0(IBND,N-L+2)
      IB=ID+J
      IF(A(IB)) 115,130,115
  115 C=A(IB)*C1
      LB=LD-1
      DO 120 K=J,IRBW
      LB=LB+1
      IF(A(ID+K)) 119,120,119
  119 A(LB)=A(LB)-C*A(ID+K)
  120 CONTINUE
      A(IB)=C
  130 CONTINUE
  140 ID=ID+IRBW+1
C *** REDUCE RIGHT-HAND SIDE, B ***
      ID=NR+1
      DO 160 I=1,NM1
      C=B(I)
      B(I)=C/A(ID)
      IRBW=MIN0(IBM1,N-I)
      DO 150 L=1,IRBW
      K=I+L
  150 B(K)=B(K)-A(ID+L)*C
  160 ID=ID+IRBW+1
C *** BACK-SOLVE FOR HEAD CHANGE, B ***
      B(N)=B(N)/A(ID)
      DO 180 I=1,NM1
      IRBW=MIN0(IBM1,I)
      ID=ID-IRBW-1
      L=N-I
      SUM=0.
      DO 170 J=1,IRBW
  170 SUM=SUM-A(ID+J)*B(L+J)
  180 B(L)=B(L)+SUM
      RETURN
      END
