


      SUBROUTINE FMCO(XG,YG,A,Q,AR,ALPH,QBND,CFDK,CFDL,ND,IZN,JPT,KQB
     1,LQB)
C        READS ELEMENT DATA AND FORMS COEFFICIENT ARRAYS FOR MATRIX
C        EQUATION
      DIMENSION XG(1),YG(1),A(1),Q(1),AR(1),ALPH(1),QBND(1),CFDK(1)
     1,CFDL(1)
      DIMENSION ND(1),IZN(1),JPT(1),KQB(1),LQB(1)
      DIMENSION XL(4),YL(4),TFL(3),NDID(4)
      COMMON/NO/NELS,NNDS,NSTEPS,NPER,NZNS,NWELS,NQBND,NHDS,NEQ,MBWC,MBW
      COMMON/ITP/IIN,IOUT,ITA,ITB
      COMMON/IPRN/IPND
      COMMON/IND/IRAD,IUNIT,ISTD
      COMMON/SCLE/SCALE
      COMMON/BAL/SA,WQI,WQO,DQI,DQO,VLQI,VLQO,BQI,BQO,ER
C *** FORMAT LIST ***
    2 FORMAT (1H0,31X,18HPARAMETERS BY ZONE/1H ,31X,8HROTATION,6X
     1,8HAQUITARD,5X,7HSTORAGE,4X,8HRECHARGE/7H   ZONE,2X,8HX TRANS.
     2,4X,8HY TRANS.,5X,5HANGLE,6X,10HHYD. COND.,2X,11HCOEFFICIENT,4X
     3,4HRATE)
    4 FORMAT (2I5,6F10.0)
    6 FORMAT (1H ,I5,1X,6(1X,G11.5))
    8 FORMAT (16I5)
   10 FORMAT (1H0,18X,12HELEMENT DATA/9H  ELEMENT,2X,6HNODE 1,2X
     1,6HNODE 2,2X,6HNODE 3,2X,6HNODE 4,3X,4HZONE)
   11 FORMAT (1H0,8X,36HELEMENT DATA READ, OUTPUT SUPPRESSED)
   12 FORMAT (1H ,I6,5I8)
C *** FOR CAUCHY-TYPE BOUNDARIES: ***
      IF(NQBND.LE.0) GO TO 35
      CA=.5*SCALE
      DO 30 J=1,NQBND
C *** (1) FORM COEFFICIENTS ***
      K=KQB(J)
      L=LQB(J)
      TMPA=XG(K)-XG(L)
      TMPB=YG(K)-YG(L)
      DIST=CA*(TMPA*TMPA+TMPB*TMPB)**.5
      TMPA=DIST
      TMPB=DIST
      IF(IRAD.LE.0) GO TO 20
      TMPA=DIST*(2.*XG(K)+XG(L))/3.
      TMPB=DIST*(2.*XG(L)+XG(K))/3.
   20 ALF=ALPH(J)
      QB=QBND(J)
      IF(ALF.LT.1.E-30) GO TO 24
      CFDK(J)=ALF*TMPA
      CFDL(J)=ALF*TMPB
      QBND(J)=QB/ALF
      GO TO 26
   24 CFDK(J)=TMPA
      CFDL(J)=TMPB
      KQB(J)=-K
C *** (2) ADD KNOWN-FLUX COMPONENTS INTO Q-VECTOR ***
   26 Q(K)=Q(K)+QB*TMPA
   30 Q(L)=Q(L)+QB*TMPB
C *** INITIALIZE POINTER ARRAY, JPT, AND VARIABLES FOR ZONAL LOOP ***
   35 MBM1=MBWC-1
      N=MBM1*NNDS
      L=NNDS+1
      DO 40 I=1,N
   40 JPT(I)=L
      DQI=0.
      DQO=0.
      NDC=0
      NTE=0
      CA=.5
      CB=SCALE*SCALE/6.
      IW=MBWC+1
      KNT=0
C *** BEGIN ZONAL LOOP ***
      WRITE(IOUT,2)
      DO 150 IZ=1,NZNS
C *** READ AND WRITE DATA FOR EACH ZONE ***
      READ(IIN,4) KZ,NO,XTR,YTR,ANG,VLC,STR,QD
      WRITE(IOUT,6) KZ,XTR,YTR,ANG,VLC,STR,QD
C *** SCALE DATA ***
      XTR=XTR*CA
      YTR=YTR*CA
      VLC=VLC*CB
      STR=STR*CB
      QD=QD*CB
C *** COMPUTE SINE AND COSINE OF ROTATION ANGLE ***
      IF(ANG.LE.0.) GO TO 42
      ANG=.01745329*ANG
      SN=SIN(ANG)
      CS=COS(ANG)
C *** BEGIN ELEMENT LOOP WITHIN ZONE ***
   42 DO 140 I=1,NO
C *** READ NODE NUMBERS FOR EACH ELEMENT IN ZONE ***
      READ(IIN,8) IEL,(ND(NDC+J),J=1,4)
      KNT=KNT+1
      IZN(KNT)=KZ
      NE=2
      N=4
      IF(ND(NDC+4).GT.0) GO TO 45
      NE=1
      N=3
C *** COMPUTE LOCAL, ROTATED COORDINATES ***
   45 DO 50 J=1,N
      K=ND(NDC+J)
      XL(J)=XG(K)
   50 YL(J)=YG(K)
      IF(ANG.LT.1.E-20) GO TO 60
      DO 55 J=1,N
      TMPA=XL(J)
      TMPB=YL(J)
      XL(J)=TMPA*CS+TMPB*SN
   55 YL(J)=-TMPA*SN+TMPB*CS
C *** BEGIN NODAL LOOP WITHIN ELEMENT ***
   60 NT=NDC+1
      DO 135 IE=1,NE
C *** COMPUTE COEFFICIENTS FOR COORDINATE FUNCTIONS ***
      NA=ND(NT)
      NB=ND(NT+IE)
      NC=ND(NT+IE+1)
      XNA=XL(1)
      YNA=YL(1)
      XNB=XL(IE+1)
      YNB=YL(IE+1)
      XNC=XL(IE+2)
      YNC=YL(IE+2)
      BJ=YNB-YNC
      BK=YNC-YNA
      BL=YNA-YNB
      CJ=XNC-XNB
      CK=XNA-XNC
      CL=XNB-XNA
      AREA=BJ*CK-BK*CJ
      AR(NTE+IE)=CB*AREA
C *** COMPUTE ELEMENT CONTRIBUTION TO DISTRIBUTED RECHARGE-DISCHARGE ***
      TEQ=QD*AREA
C *** COMPUTE TOTAL DISTRIBUTED RECHARGE OR DISCHARGE PER UNIT
C     TIME FOR FLOW BALANCE ***
      IF(QD.GT.0.) GO TO 65
      DQO=DQO+TEQ
      GO TO 70
   65 DQI=DQI+TEQ
C *** ADD DISTRIBUTED RECHARGE-DISCHARGE INTO Q-VECTOR ***
   70 Q(NA)=Q(NA)+TEQ
      Q(NB)=Q(NB)+TEQ
      Q(NC)=Q(NC)+TEQ
C *** COMPUTE ELEMENT CONTRIBUTIONS TO CAPACITANCE, LEAKANCE,
C     AND FLOW DIVERGENCE ***
      TESJ=STR*AREA
      TESK=TESJ
      TESL=TESJ
      XT=XTR/AREA
      YT=YTR/AREA
      IF(IRAD.LE.0) GO TO 75
      TESJ=TESJ*.25*(2.*XNA+XNB+XNC)
      TESK=TESK*.25*(2.*XNB+XNA+XNC)
      TESL=TESL*.25*(2.*XNC+XNA+XNB)
      TMPA=(XNA+XNB+XNC)/3.
      XT=XT*TMPA
      YT=YT*TMPA
   75 TEL=VLC*AREA
      TXJ=XT*BJ
      TYJ=YT*CJ
      TXL=XT*BL
      TYL=YT*CL
      TFL(1)=TXJ*BK+TYJ*CK
      TFL(2)=TXL*BK+TYL*CK
      TFL(3)=TXJ*BL+TYJ*CL
C *** ADD ELEMENT CONTRIBUTIONS FOR CAPACITANCE AND LEAKANCE INTO
C     A-MATRIX ***
      ICA=IW*(NA-1)+1
      ICB=IW*(NB-1)+1
      ICC=IW*(NC-1)+1
      A(ICA)=A(ICA)+TESJ
      A(ICB)=A(ICB)+TESK
      A(ICC)=A(ICC)+TESL
      A(ICA+1)=A(ICA+1)+TEL
      A(ICB+1)=A(ICB+1)+TEL
      A(ICC+1)=A(ICC+1)+TEL
C *** ADD ELEMENT CONTRIBUTIONS FOR FLOW DIVERGENCE INTO A-MATRIX AND
C     FORM JPT ***
      NDID(1)=NA
      NDID(2)=NB
      NDID(3)=NC
      NDID(4)=NA
      DO 130 J=1,3
      NA=NDID(J)
      NB=NDID(J+1)
      IF(NB.GT.NA) GO TO 80
      NA=NB
      NB=NDID(J)
   80 M=IW*(NA-1)+1
      M1=MBM1*(NA-1)
      K=0
      DO 90 KK=1,MBM1
      K=K+1
      L=JPT(M1+K)
      IF(L-NB) 90,100,110
   90 CONTINUE
  100 A(M+K+1)=A(M+K+1)+TFL(J)
      GO TO 130
  110 KK=MBM1-K
      L=MBWC
      DO 120 LL=1,KK
      L=L-1
      JPT(M1+L)=JPT(M1+L-1)
  120 A(M+L+1)=A(M+L)
      JPT(M1+K)=NB
      A(M+K+1)=TFL(J)
  130 CONTINUE
  135 CONTINUE
      NTE=NTE+2
  140 NDC=NDC+4
  150 CONTINUE
C *** WRITE ELEMENT NODE AND ZONE NUMBERS ***
      IF(IPND.GT.0) GO TO 162
      WRITE(IOUT,10)
      NDC=0
      DO 160 I=1,NELS
      WRITE(IOUT,12) I,(ND(NDC+J),J=1,4),IZN(I)
      IZN(I)=0
  160 NDC=NDC+4
      GO TO 166
  162 WRITE(IOUT,11)
      DO 164 I=1,NELS
  164 IZN(I)=0
C *** ADJUST TOTAL RECHARGE AND DISCHARGE PER UNIT TIME ***
  166 DQI=3.*DQI
      DQO=3.*DQO
      RETURN
      END
