


      SUBROUTINE FMECWT(H,DH,DHB,HR,HK,HL,CFDK,CFDL,A,AD,Q,B,THK,DTK
     1,TOP,ASY,DT,JPT,IN,KQB,LQB)
C        FORMS CONDENSED COEFFICIENT MATRIX, A, AND RIGHT-HAND-SIDE
C        VECTOR, B, FOR WATER-TABLE CORRECTOR STEP
      DIMENSION H(1),DH(1),DHB(1),HR(1),HK(1),HL(1),CFDK(1),CFDL(1)
     1,A(1),AD(1),Q(1),B(1),THK(1),DTK(1),TOP(1),ASY(1)
      DIMENSION JPT(1),IN(1),KQB(1),LQB(1)
      COMMON/NO/NELS,NNDS,NSTEPS,NPER,NZNS,NWELS,NQBND,NHDS,NEQ,MBWC,MBW
      COMMON/ITP/IIN,IOUT,ITA,ITB
      COMMON/BAL/SA,WQI,WQO,DQI,DQO,VLQI,VLQO,BQI,BQO,ER
C *** FORMAT LIST ***
    1 FORMAT (1H0,5HNODE ,I5,20H PREDICTED TO BE DRY/1H ,3X
     1,38HPREDICTED AQUIFER THICKNESS AT NODE = ,G11.5/1H ,3X
     2,19HNET FLOW AT NODE = ,G11.5)
    2 FORMAT (1H ,3X,30HNET FLUX FROM NODE REDUCED TO ,G11.5)
      WF=2./3.
      IW=MBWC+1
      NC=1
      DO 25 I=1,NNDS
C *** INITIALIZE  DTK-VECTOR ***
      DTK(I)=0.
      J=IN(I)
      IF(J.GT.0) GO TO 12
C *** COMPUTE DTK-VECTOR AT SPECIFIED-HEAD NODES ***
      HO=H(I)-DHB(-J)
      DHP=1.5*DHB(-J)
      HP=HO+DHP
      IF(HO.LT.TOP(I)) GO TO 8
      IF(HP.GT.TOP(I)) GO TO 25
      DTK(I)=HP-TOP(I)
      GO TO 20
    8 IF(HP.LT.TOP(I)) GO TO 10
      DTK(I)=TOP(I)-HO
      GO TO 20
   10 DTK(I)=DHP
      GO TO 20
C *** COMPUTE OLD AND PREDICTED HEADS AT ACTIVE NODES ***
   12 HO=H(I)-DH(J)
      DHP=1.5*DH(J)
      HP=HO+DHP
C *** INITIALIZE MATRIX DIAGONAL, AD, AND B-VECTOR ***
      AD(J)=0.
      B(J)=0.
      IF(HO.LT.TOP(I)) GO TO 14
      IF(HP.GE.TOP(I)) GO TO 25
C *** FOR ACTIVE NODES CONVERTING FROM CONFINED TO UNCONFINED
C     CONDITIONS: ***
C *** (1) COMPUTE PREDICTED HEAD AND DTK-VECTOR FOR NODES THAT ARE
C     SATURATED ***
      HP=(A(NC)/ASY(I))*(HP-TOP(I))+TOP(I)
      DHP=HP-HO
      DH(J)=WF*DHP
      H(I)=HO+DH(J)
      DTK(I)=HP-TOP(I)
C *** (2) MODIFY B-VECTOR AND DEFINE CAPACITANCE TERM, A, AS ASY ***
      B(J)=B(J)+(ASY(I)-A(NC))*(TOP(I)-HO)/DT
      A(NC)=ASY(I)
C *** (3) COMPUTE DTK-VECTOR AND IDENTIFY AND REDUCE DISCHARGE AT NODES
C     THAT ARE PREDICTED TO GO DRY ***
      IF(THK(I)+DTK(I).GT.0.) GO TO 20
      THKP=THK(I)+DTK(I)
      WRITE(IOUT,1) I,THKP,Q(I)
      DTK(I)=-THK(I)
      IF(Q(I).GE.0.) GO TO 20
      Q(I)=.5*Q(I)
      WQO=WQO-Q(I)
      WRITE(IOUT,2) Q(I)
      GO TO 20
C *** COMPUTE DTK-VECTOR AND MODIFY B-VECTOR AT ACTIVE NODES
C     CONVERTING FROM UNCONFINED TO CONFINED CONDITIONS ***
   14 IF(HP.LT.TOP(I)) GO TO 16
      DTK(I)=TOP(I)-HO
      B(J)=B(J)+(A(NC)-ASY(I))*DTK(I)/DT
      GO TO 20
C *** FOR UNCONFINED ACTIVE NODES: ***
C *** (1) DEFINE CAPACITANCE TERM, A, AS ASY ***
   16 A(NC)=ASY(I)
C *** (2) COMPUTE DTK-VECTOR AND IDENTIFY AND REDUCE DISCHARGE AT
C     NODES THAT ARE DRY ***
      IF(THK(I)+DHP.GT.0.) GO TO 18
      DTK(I)=0.
      IF(THK(I).GT.0.) DTK(I)=-THK(I)
      THKP=THK(I)+DHP
      WRITE(IOUT,1) I,THKP,Q(I)
      IF(Q(I).GE.0..OR.DHP.GE.0.) GO TO 20
      Q(I)=.5*Q(I)
      WQO=WQO-Q(I)
      WRITE(IOUT,2) Q(I)
      GO TO 20
   18 DTK(I)=DHP
      IF(THK(I).LT.0.) DTK(I)=DHP+THK(I)
C *** MODIFY DTK-VECTOR AND DEFINE PH-VECTOR ***
   20 DTK(I)=WF*DTK(I)
   25 NC=NC+IW
C *** INITIALIZE FOR NODAL ASSEMBLY LOOP ***
      DTM=3./(2.*DT)
      MBM1=MBWC-1
      C1=9./16.
      C2=8./9.
      C3=1./16.
      NC=1
      NME=1
      NP=0
      DO 80 I=1,NNDS
      NVL=NC+1
      ND=NVL
C *** COMPUTE A-MATRIX AND B-VECTOR EXCEPT FOR BOUNDARY CONDITION
C     CONTRIBUTIONS ***
      THKI=THK(I)
      IF(THKI.LT.0.) THKI=0.
      K=IN(I)
      IF(K.LT.0) GO TO 64
      TMPA=A(NC)*DTM
      B(K)=B(K)-TMPA*DH(K)+A(NVL)*(HR(I)-H(I))+Q(I)
      AD(K)=AD(K)+TMPA+A(NVL)
      DO 50 J=1,MBM1
      L=JPT(NP+J)
      IF(L.GT.NNDS) GO TO 60
      THKL=THK(L)
      IF(THKL.LT.0.) THKL=0.
      TMPA=C1*(DTK(I)+DTK(L)+C2*(THKI+THKL))*A(ND+J)
      AD(K)=AD(K)-TMPA
      M=IN(L)
      IF(M.GT.0) GO TO 40
      M=-M
      B(K)=B(K)-(C3*(DTK(I)+DTK(L))*(DHB(M)-DH(K))
     1+.5*(DTK(I)+DTK(L)+THKI+THKL)*(H(L)-H(I)))*A(ND+J)
      A(NME+J)=0.
      GO TO 50
   40 TMPB=(C3*(DTK(I)+DTK(L))*(DH(M)-DH(K))
     1+.5*(DTK(I)+DTK(L)+THKI+THKL)*(H(L)-H(I)))*A(ND+J)
      B(K)=B(K)-TMPB
      B(M)=B(M)+TMPB
      A(NME+J)=TMPA
      AD(M)=AD(M)-TMPA
   50 CONTINUE
   60 NME=NME+MBWC
      GO TO 70
   64 K=-K
      DO 66 J=1,MBM1
      L=JPT(NP+J)
      M=IN(L)
      IF(M) 66,70,65
   65 THKL=THK(L)
      IF(THKL.LT.0.) THKL=0.
      B(M)=B(M)-(C3*(DTK(I)+DTK(L))*(DHB(K)-DH(M))
     1+.5*(DTK(I)+DTK(L)+THKI+THKL)*(H(I)-H(L)))*A(ND+J)
      AD(M)=AD(M)-C1*(DTK(I)+DTK(L)+C2*(THKI+THKL))*A(ND+J)
   66 CONTINUE
   70 NC=NC+IW
   80 NP=NP+MBM1
      N=NNDS-NHDS
      NME=1
      J=0
      DO 85 I=1,N
      A(NME)=AD(I)
      J=J+1
   85 NME=NME+MBWC
C *** ADD CONTRIBUTIONS FROM CAUCHY-TYPE BOUNDARIES INTO A AND B ***
      IF(NQBND.LE.0) RETURN
      DO 130 I=1,NQBND
      K=KQB(I)
      IF(K.LT.0) GO TO 130
      L=LQB(I)
      KE=IN(K)
      IF(KE.LT.0) GO TO 100
      M=MBWC*(KE-1)+1
      A(M)=A(M)+CFDK(I)
      B(KE)=B(KE)+CFDK(I)*(HK(I)-H(K))
  100 LE=IN(L)
      IF(LE.LT.0) GO TO 130
      N=MBWC*(LE-1)+1
      A(N)=A(N)+CFDL(I)
      B(LE)=B(LE)+CFDL(I)*(HL(I)-H(L))
  130 CONTINUE
      RETURN
      END
