      SUBROUTINE FMEPWT(H,HR,HK,HL,CFDK,CFDL,A,AD,Q,B,THK,TOP,ASY,DT,JPT
     1,IN,KQB,LQB)
C        FORMS CONDENSED COEFFICIENT MATRIX, A, AND RIGHT-HAND-SIDE
C        VECTOR, B, FOR WATER-TABLE PREDICTOR STEP
      DIMENSION H(1),HR(1),HK(1),HL(1),CFDK(1),CFDL(1),A(1),AD(1),Q(1)
     1,B(1),THK(1),TOP(1),ASY(1)
      DIMENSION JPT(1),IN(1),KQB(1),LQB(1)
      COMMON/NO/NELS,NNDS,NSTEPS,NPER,NZNS,NWELS,NQBND,NHDS,NEQ,MBWC,MBW
      IW=MBWC+1
      NC=1
      DO 10 I=1,NEQ
      J=IN(I)
      IF(J.LT.0) GO TO 10
C *** INITIALIZE MATRIX DIAGONAL, AD, AND B-VECTOR ***
      AD(J)=0.
      B(J)=0.
C *** DEFINE CAPACITANCE FOR WATER-TABLE NODES AS THE NODAL SPECIFIC
C     YIELD COEFFICIENTS, ASY ***
      IF(H(I).LE.TOP(I)) A(NC)=ASY(I)
   10 NC=NC+IW
C *** INITIALIZE FOR NODAL ASSEMBLY LOOP ***
      DTM=3./(2.*DT)
      MBM1=MBWC-1
      NC=1
      NME=1
      NP=0
C *** COMPUTE A-MATRIX AND B-VECTOR EXCEPT FOR BOUNDARY-CONDITION
C     CONTRIBUTIONS ***
      DO 80 I=1,NNDS
      NVL=NC+1
      ND=NVL
      THKI=THK(I)
      IF(THKI.LT.0.) THKI=0.
      K=IN(I)
      IF(K.LT.0) GO TO 64
      B(K)=B(K)+A(NVL)*(HR(I)-H(I))+Q(I)
      AD(K)=AD(K)+A(NC)*DTM+A(NVL)
      DO 50 J=1,MBM1
      L=JPT(NP+J)
      IF(L.GT.NNDS) GO TO 60
      THKL=THK(L)
      IF(THKL.LT.0.) THKL=0.
      TMPA=.5*(THKI+THKL)*A(ND+J)
      TMPB=TMPA*(H(L)-H(I))
      B(K)=B(K)-TMPB
      AD(K)=AD(K)-TMPA
      M=IN(L)
      IF(M.GT.0) GO TO 40
      A(NME+J)=0.
      GO TO 50
   40 B(M)=B(M)+TMPB
      A(NME+J)=TMPA
      AD(M)=AD(M)-TMPA
   50 CONTINUE
   60 NME=NME+MBWC
      GO TO 70
   64 DO 66 J=1,MBM1
      L=JPT(NP+J)
      M=IN(L)
      IF(M) 66,70,65
   65 THKL=THK(L)
      IF(THKL.LT.0.) THKL=0.
      TMPA=.5*(THKI+THKL)*A(ND+J)
      B(M)=B(M)-TMPA*(H(I)-H(L))
      AD(M)=AD(M)-TMPA
   66 CONTINUE
   70 NC=NC+IW
   80 NP=NP+MBM1
      N=NNDS-NHDS
      NME=1
      DO 85 I=1,N
      A(NME)=AD(I)
   85 NME=NME+MBWC
C *** ADD CONTRIBUTIONS FROM CAUCHY-TYPE BOUNDARIES INTO A AND B ***
      IF(NQBND.LE.0) RETURN
      DO 130 I=1,NQBND
      K=KQB(I)
      IF(K.LT.0) GO TO 130
      L=LQB(I)
      KE=IN(K)
      IF(KE.LT.0) GO TO 100
      M=MBWC*(KE-1)+1
      A(M)=A(M)+CFDK(I)
      B(KE)=B(KE)+CFDK(I)*(HK(I)-H(K))
  100 LE=IN(L)
      IF(LE.LT.0) GO TO 130
      N=MBWC*(LE-1)+1
      A(N)=A(N)+CFDL(I)
      B(LE)=B(LE)+CFDL(I)*(HL(I)-H(L))
  130 CONTINUE
      RETURN
      END
