      SUBROUTINE GNBAL(H,DH,DHB,R,GC,HRK,HRL,ZRK,ZRL,ZP,VQK,VQL,DT,IN,KR
     1,LR,KP,NBNC,NPNB)
C        COMPUTES FLOW-BALANCE COMPONENTS FOR NONLINEAR CAUCHY-TYPE
C        BOUNDARIES AND NONLINEAR POINT SINKS
      DIMENSION H(1),DH(1),DHB(1),R(1),GC(1),HRK(1),HRL(1),ZRK(1),ZRL(1)
     1,ZP(1),VQK(1),VQL(1)
      DIMENSION IN(1),KR(1),LR(1),KP(1),NL(2)
      DIMENSION HR(2),ZR(2),QR(2)
      COMMON/BAL/SA,WQI,WQO,DQI,DQO,VLQI,VLQO,BQI,BQO,ER
      COMMON/GNBL/BNQI,BNQO,TBNQI,TBNQO,PNQO,TPNQO
C *** SET VOLUMETRIC-FLOW RATES TO ZERO ***
      BNQI=0.
      BNQO=0.
      PNQO=0.
C *** COMPUTE WEIGHTING FACTORS FOR GALERKIN-IN-TIME FORMULATION ***
      CA=1./3.
      CB=2./3.
C ***
      IF(NBNC.LT.1) GO TO 65
C *** FORM COEFFICIENTS FOR EACH SIDE J ON A NONLINEAR CAUCHY-TYPE
C     BOUNDARY ***
      DO 60 J=1,NBNC
      HR(1)=HRK(J)
      HR(2)=HRL(J)
      ZR(1)=ZRK(J)
      ZR(2)=ZRL(J)
      NL(1)=KR(J)
      NL(2)=LR(J)
C *** FOR EACH NODE I ON THE SIDE: ***
      DO 50 I=1,2
C *** (1) COMPUTE HEAD AT N LEVEL, HO, AND HEAD AT N+1 LEVEL, HC ***
      L=NL(I)
      LE=IN(L)
      IF(LE.LT.0) GO TO 10
      DHC=DH(LE)
      GO TO 15
   10 DHC=DHB(-LE)
   15 HO=H(L)-DHC
      DHC=1.5*DHC
      HC=HO+DHC
C *** (2) REPRESENT ELEVATIONS, AND HEAD AND ELEVATION DIFFERENCES, BY
C         TEMPORARY (UNSUBSCRIPTED) VARIABLES ***
      ZRI=ZR(I)
      HRI=HR(I)
      DRZ=HRI-ZRI
      DHZ=HO-ZRI
C *** (3) COMPARE HEADS WITH CONTROLLING ELEVATIONS TO IDENTIFY LEAKAGE
C         CASE. COMPUTE HEAD DIFFERENCE, TMPA, FOR VOLUMETRIC-FLOW RATES
C         FOR: ***
      IF(HO.LT.ZRI) GO TO 30
      IF(HC.LT.ZRI) GO TO 20
C *** CASE (1) ***
      TMPA=HRI-H(L)
      GO TO 40
C *** CASE (2) ***
   20 PHI=DHZ/DHC
      TMPA=DRZ-CA*PHI*PHI*DHZ
      GO TO 40
   30 IF(HC.GT.ZRI) GO TO 35
C *** CASE (4) ***
      TMPA=DRZ
      GO TO 40
C *** CASE (3) ***
   35 PHC=1.+DHZ/DHC
      TMPA=DRZ-CB*PHC*(HC-ZRI)
C *** (4) COMPUTE VOLUMETRIC-FLOW RATE ***
   40 TMPB=GC(J)*TMPA
      QR(I)=TMPB
C *** (5) INCLUDE VOLUMETRIC-FLOW RATE INTO FLOW-BALANCE EQUATION AT
C         SPECIFIED-HEAD NODE ***
      IF(LE.LT.0) R(-LE)=R(-LE)-TMPB
C *** (6) SUM VOLUMETRIC-FLOW RATES ACCORDING TO SIGN, POSITIVE
C         FOR INFLOW ***
      IF(TMPB.LT.0.) GO TO 45
      BNQI=BNQI+TMPB
      GO TO 50
   45 BNQO=BNQO+TMPB
   50 CONTINUE
      VQK(J)=QR(1)
      VQL(J)=QR(2)
   60 CONTINUE
C *** COMPUTE TOTAL VOLUMES TO BE RECHARGED (+) AND DICHARGED (-) ACROSS
C     BOUNDARY FOR ENTIRE SIMULATION ***
      TBNQI=TBNQI+BNQI*DT
      TBNQO=TBNQO+BNQO*DT
C *** INCLUDE VOLUMETRIC-FLOW RATES IN THE FLOW IMBALANCE ***
      ER=ER-BNQI-BNQO
C ***
   65 IF(NPNB.LT.1) RETURN
C *** FORM COEFFICIENTS FOR NONLINEAR POINT SINKS ***
C *** FOR EACH POINT I: ***
      DO 100 I=1,NPNB
      K=KP(I)
      KE=IN(K)
      IF(KE.LT.0) GO TO 70
      DHC=DH(KE)
      GO TO 75
   70 DHC=DHB(-KE)
   75 IP=I+NBNC
C *** (1) COMPUTE HEAD AT N LEVEL, HO, AND HEAD AT N+1 LEVEL, HC ***
      HO=H(K)-DHC
      DHC=1.5*DHC
      HC=HO+DHC
C *** (2) REPRESENT ELEVATION, AND HEAD AND ELEVATION DIFFERENCE, BY
C         TEMPORARY (UNSUBSCRIPTED) VARIABLES ***
      ZPI=ZP(I)
      DHZ=ZPI-HO
C *** (3) COMPARE HEADS WITH CONTROLLING ELEVATION TO IDENTIFY LEAKAGE
C         CASE. COMPUTE HEAD DIFFERENCE, TMPA, FOR VOLUMETRIC-FLOW RATES
C         FOR: ***
      IF(HO.GT.ZPI) GO TO 80
      IF(HC.LT.ZPI) GO TO 100
C *** CASE (3) ***
      PHC=1.-DHZ/DHC
      TMPA=CB*PHC*(ZPI-HC)
      GO TO 90
   80 IF(HC.GT.ZPI) GO TO 85
C *** CASE (2) ***
      PHI=DHZ/DHC
      TMPA=CA*PHI*PHI*DHZ
      GO TO 90
C *** CASE (1) ***
   85 TMPA=ZPI-H(K)
C *** (4) COMPUTE VOLUMERIC-FLOW RATE ***
   90 TMPB=GC(IP)*TMPA
C *** (5) INCLUDE VOLUMETRIC-FLOW RATE INTO FLOW-BALANCE EQUATION AT
C         SPECIFIED-HEAD NODE ***
      IF(KE.LT.0) R(-KE)=R(-KE)-TMPB
C *** (6) SUM VOLUMETRIC-FLOW RATES ***
      PNQO=PNQO+TMPB
  100 CONTINUE
C *** COMPUTE TOTAL VOLUME DISCHARGED ACROSS POINTS FOR ENTIRE
C     SIMULATION ***
      TPNQO=TPNQO+PNQO*DT
C *** INCLUDE VOLUMETRIC-FLOW RATES IN THE FLOW IMBALANCE ***
      ER=ER-PNQO
      RETURN
      END
