



      SUBROUTINE GNBLSS(H,R,GC,HRK,HRL,ZRK,ZRL,ZP,VQK,VQL,DT,IN,KR,LR,KP
     1,NBNC,NPNB)
C        COMPUTES FLOW-BALANCE COMPONENTS FOR NONLINEAR CAUCHY-TYPE
C        BOUNDARIES AND NONLINEAR POINT SINKS FOR STEADY-STATE
C        SIMULATIONS
      DIMENSION H(1),R(1),GC(1),HRK(1),HRL(1),ZRK(1),ZRL(1),ZP(1),VQK(1)
     1,VQL(1)
      DIMENSION IN(1),KR(1),LR(1),KP(1),NL(2)
      DIMENSION HR(2),ZR(2),QR(2)
      COMMON/BAL/SA,WQI,WQO,DQI,DQO,VLQI,VLQO,BQI,BQO,ER
      COMMON/GNBL/BNQI,BNQO,TBNQI,TBNQO,PNQO,TPNQO
C *** SET VOLUMETRIC-FLOW RATES TO ZERO ***
      BNQI=0.
      BNQO=0.
      PNQO=0.
C ***
      IF(NBNC.LT.1) GO TO 65
C *** FORM COEFFICIENTS FOR EACH SIDE J ON A NONLINEAR CAUCHY-TYPE
C     BOUNDARY ***
      DO 60 J=1,NBNC
      HR(1)=HRK(J)
      HR(2)=HRL(J)
      ZR(1)=ZRK(J)
      ZR(2)=ZRL(J)
      NL(1)=KR(J)
      NL(2)=LR(J)
C *** FOR EACH NODE I ON THE SIDE: ***
      DO 50 I=1,2
      L=NL(I)
C *** (1) REPRESENT HEADS AND CONTROLLING ELEVATION BY TEMPORARY
C         (UNSUBSCRIPTED) VARIABLES ***
      HL=H(L)
      HRI=HR(I)
      ZRI=ZR(I)
C *** (2) COMPARE HEAD WITH CONTROLLING ELEVATION TO IDENTIFY LEAKAGE
C         CASE. COMPUTE HEAD DIFFERENCE, TMPA, FOR VOLUMETRIC-FLOW RATES
C         FOR: ***
      IF(HL.GT.ZRI) GO TO 20
C *** CASE (4) ***
      TMPA=HRI-ZRI
      GO TO 30
C *** CASE (1) ***
   20 TMPA=HRI-HL
C *** (3) COMPUTE VOLUMETRIC-FLOW RATE ***
   30 TMPB=GC(J)*TMPA
      QR(I)=TMPB
C *** (4) INCLUDE VOLUMETRIC-FLOW RATE INTO FLOW-BALANCE EQUATION AT
C         SPECIFIED-HEAD NODE ***
      LE=-IN(L)
      IF(LE.GT.0) R(LE)=R(LE)-TMPB
C *** (5) SUM VOLUMETRIC-FLOW RATES ACCORDING TO SIGN, POSITIVE FOR
C         INFLOW ***
      IF(TMPB.LT.0.) GO TO 40
      BNQI=BNQI+TMPB
      GO TO 50
   40 BNQO=BNQO+TMPB
   50 CONTINUE
      VQK(J)=QR(1)
      VQL(J)=QR(2)
   60 CONTINUE
C *** COMPUTE TOTAL VOLUMES RECHARGED (+) AND DISCHARGED (-) ACROSS
C     BOUNDARY FOR SIMULATION ***
      TBNQI=BNQI*DT
      TBNQO=BNQO*DT
C *** INCLUDE VOLUMETRIC-FLOW RATES IN THE FLOW IMBALANCE ***
      ER=ER-BNQI-BNQO
C ***
   65 IF(NPNB.LT.1) RETURN
C *** FORM COEFFICIENTS FOR NONLINEAR POINT SINKS ***
C *** FOR EACH POINT I: ***
      DO 80 I=1,NPNB
      K=KP(I)
      IP=I+NBNC
C *** REPRESENT HEAD AND CONTOLLING ELEVATION BY TEMPORARY
C     (UNSUBSCRIPTED) VARIABLES ***
      HK=H(K)
      ZPI=ZP(I)
C *** COMPARE HEAD WITH CONTROLLING ELEVATION TO DETERMINE LEAKAGE
C     CASE ***
      IF(HK.GT.ZPI) GO TO 70
C *** NO LEAKAGE, THUS NO COMPUTATION ***
      GO TO 80
C *** LEAKAGE, THUS COMPUTE VOLUMETRIC-FLOW RATE ***
   70 TMPB=GC(IP)*(ZPI-HK)
C *** INCLUDE VOLUMETRIC-FLOW RATE INTO FLOW-BALANCE EQUATION AT
C     SPECIFIED-HEAD NODES ***
      KE=-IN(K)
      IF(KE.GT.0) R(KE)=R(KE)-TMPB
C *** SUM VOLUMETRIC-FLOW RATES ***
      PNQO=PNQO+TMPB
   80 CONTINUE
C *** COMPUTE TOTAL VOLUME DISCHARGED ACROSS BOUNDARY FOR SIMULATION ***
      TPNQO=PNQO*DT
C *** INCLUDE VOLUMETRIC-FLOW RATES INTO FLOW IMBALANCE ***
      ER=ER-PNQO
      RETURN
      END
