


      SUBROUTINE GNCORR(H,DH,A,B,GC,HRK,HRL,ZRK,ZRL,ZP,IN,KR,LR,KP
     1,NBNC,NPNB)
C        FORMS COEFFICIENTS FOR NONLINEAR CAUCHY-TYPE BOUNDARIES AND
C        NONLINEAR POINT SINKS; ADDS TERMS TO MATRIX EQUATION FOR
C        THE CORRECTOR
      DIMENSION H(1),DH(1),A(1),B(1),GC(1),HRK(1),HRL(1),ZRK(1),ZRL(1)
     1,ZP(1)
      DIMENSION IN(1),KR(1),LR(1),KP(1)
      DIMENSION HR(2),ZR(2),NL(2)
      COMMON/NO/NELS,NNDS,NSTEPS,NPER,NZNS,NWELS,NQBND,NHDS,NEQ,MBWC,MBW
C *** COMPUTE WEIGHTING FACTORS FOR GALERKIN-IN-TIME FORMULATION ***
      CA=1./3.
      CB=2./3.
C ***
      IF(NBNC.LT.1) GO TO 110
C *** FORM COEFFICIENTS FOR EACH SIDE J ON A NONLINEAR CAUCHY-TYPE
C     BOUNDARY ***
      DO 100 J=1,NBNC
      HR(1)=HRK(J)
      HR(2)=HRL(J)
      ZR(1)=ZRK(J)
      ZR(2)=ZRL(J)
      NL(1)=KR(J)
      NL(2)=LR(J)
C *** FOR EACH NODE I ON THE SIDE: ***
      DO 50 I=1,2
      L=NL(I)
      LE=IN(L)
C *** (1) BYPASS SPECIFIED-HEAD NODES ***
      IF(LE.LT.0) GO TO 50
      N=MBWC*(LE-1)+1
C *** (2) REPRESENT HEADS, ELEVATIONS, AND DIFFERENCES BY TEMPORARY
C         (UNSUBSCRIPTED) VARIABLES ***
      HO=H(L)-DH(LE)
      DHP=1.5*DH(LE)
      HP=HO+DHP
      ZRI=ZR(I)
      HRI=HR(I)
      DRZ=HRI-ZRI
      DHZ=HO-ZRI
C *** (3) COMPARE HEADS WITH CONTROLLING ELEVATIONS TO IDENTIFY LEAKAGE
C         CASE. ADD LEAKAGE COEFFICIENT TO MAIN DIAGONAL, IF APPLICABLE,
C         AND COMPUTE HEAD DIFFERENCE, TMPA, FOR RIGHT-SIDE TERM
C         FOR: ***
      IF(HO.LT.ZRI) GO TO 30
      IF(HP.LT.ZRI) GO TO 20
C *** CASE (1) ***
      A(N)=A(N)+GC(J)
      TMPA=HRI-H(L)
      GO TO 40
C *** CASE (2) ***
   20 PHI=DHZ/DHP
      TMPA=DRZ-CA*PHI*PHI*DHZ
      GO TO 40
   30 IF(HP.GT.ZRI) GO TO 35
C *** CASE (4) ***
      TMPA=DRZ
      GO TO 40
C *** CASE (3) ***
   35 PHC=1.+DHZ/DHP
      A(N)=A(N)+PHC*GC(J)
      TMPA=DRZ-CB*PHC*(HP-ZRI)
C *** (4) COMPUTE RIGHT-SIDE TERM AND ADD TO B-VECTOR ***
   40 B(LE)=B(LE)+GC(J)*TMPA
   50 CONTINUE
  100 CONTINUE
C ***
  110 IF(NPNB.LT.1) RETURN
C *** FORM COEFFICIENTS FOR NONLINEAR POINT SINKS ***
C *** FOR EACH POINT I: ***
      DO 150 I=1,NPNB
      K=KP(I)
      KE=IN(K)
C *** (1) BYPASS SPECIFIED-HEAD NODES ***
      IF(KE.LT.0) GO TO 150
      N=MBWC*(KE-1)+1
      IP=I+NBNC
C *** (2) REPRESENT HEADS, ELEVATION, AND DIFFERENCE BY TEMPORARY
C         (UNSUBSCRIPTED) VARIABLES ***
      HO=H(K)-DH(KE)
      DHP=1.5*DH(KE)
      HP=HO+DHP
      ZPI=ZP(I)
      DHZ=ZPI-HO
C *** (3) COMPARE HEADS WITH CONTROLLING ELEVATION TO IDENTIFY LEAKAGE
C         CASE. ADD LEAKAGE COEFFICIENT TO MAIN DIAGONAL, IF APPLICABLE,
C         AND COMPUTE HEAD DIFFERENCE, TMPA, FOR RIGHT-SIDE TERM
C         FOR: ***
      IF(HO.GT.ZPI) GO TO 120
      IF(HP.LT.ZPI) GO TO 150
C *** CASE (3) ***
      PHC=1.-DHZ/DHP
      A(N)=A(N)+GC(IP)*PHC
      TMPA=CB*PHC*(ZPI-HP)
      GO TO 140
  120 IF(HP.GT.ZPI) GO TO 130
C *** CASE (2) ***
      PHI=DHZ/DHP
      TMPA=CA*PHI*PHI*DHZ
      GO TO 140
C *** CASE (1) ***
  130 A(N)=A(N)+GC(IP)
      TMPA=ZPI-H(K)
C *** (4) COMPUTE RIGHT-SIDE TERM AND ADD TO B-VECTOR ***
  140 B(KE)=B(KE)+GC(IP)*TMPA
  150 CONTINUE
      RETURN
      END
