




      SUBROUTINE GNFMCO(XG,YG,GC,HRK,HRL,ZRK,ZRL,ZP,KR,LR,KP,INLZ,INLS
     1,NBNC,NPNB,NLCZ)
C        READS AND WRITES DATA AND COMPUTES LEAKAGE COEFFICIENTS FOR
C        NONLINEAR CAUCHY-TYPE BOUNDARIES AND NONLINEAR POINT SINKS
      DIMENSION XG(1),YG(1),GC(1),HRK(1),HRL(1),ZRK(1),ZRL(1),ZP(1)
      DIMENSION KR(1),LR(1),KP(1),INLZ(1),INLS(1)
      COMMON/ITP/IIN,IOUT,ITA,ITB
      COMMON/SCLE/SCALE
C *** FORMAT LIST ***
    2 FORMAT (1H0,13X,52HNONLINEAR CAUCHY-TYPE BOUNDARY DATA BY BOUNDARY
     1 ZONE)
    3 FORMAT (1H0,5X,5HZONE ,I5,4X,9HCONTAINS ,I5,15H BOUNDARY SIDES
     1/1H ,7X,4HSIDE,6X,7HLEAKAGE,19X,8HEXTERNAL,4X,11HCONTROLLING/1H
     2,8X,3HNO.,4X,11HCOEFFICIENT,7X,4HNODE,8X,4HHEAD,7X,9HELEVATION)
    4 FORMAT (F10.0)
    5 FORMAT (1H0,8X,50HNONLINEAR CAUCHY-TYPE DATA READ, OUTPUT SUPPRESS
     1ED)
    6 FORMAT (3I5,5F10.0)
    7 FORMAT (1H ,2(5X,I5,6X,G11.5),3X,G11.5/1H ,32X,I5,3X,2(3X,G11.5))
    8 FORMAT (1H0,16X,25HNONLINEAR POINT SINK DATA/1H ,6X,5HPOINT,5X
     1,4HNODE,8X,7HLEAKAGE,6X,11HCONTROLLING/1H ,7X,3HNO.,7X,3HNO.,6X
     2,11HCOEFFICIENT,5X,9HELEVATION)
    9 FORMAT(1H0,8X,48HNONLINEAR POINT SINK DATA READ,OUTPUT SUPPRESSED)
   10 FORMAT (2I5,2F10.0)
   12 FORMAT (1H ,4X,I5,5X,I5,2X,2(5X,G11.5))
C *** COMPUTE FACTORING AND SCALING TERM FOR BOUNDARY LENGTHS ***
      CA=.5*SCALE
C *** READ INDICATOR VARIABLES FOR SUPRESSING PRINTOUT OF NONLINEAR-
C     BOUNDARY DATA ***
      READ(IIN,6) IPNC,IPNP
      IF(NBNC.LT.1) GO TO 30
C *** FOR NONLINEAR CAUCHY-TYPE BOUNDARIES: ***
      IF(IPNC.GT.0) GO TO 14
      WRITE(IOUT,2)
      GO TO 15
   14 WRITE(IOUT,5)
C *** (1) READ AND WRITE DATA DEFINING BOUNDARY SIDE I ***
   15 DO 19 NZ=1,NLCZ
      READ(IIN,6) KZ,NOS,IZIN
      IF(IPNC.EQ.0) WRITE(IOUT,3) KZ,NOS
      INLZ(NZ)=KZ
      INLS(NZ)=NOS
      IF(IZIN.GT.0) GO TO 17
      DO 16 I=1,NOS
      READ(IIN,6) J,KR(J),LR(J),GC(J),HRK(J),HRL(J),ZRK(J),ZRL(J)
      IF(IPNC.EQ.0) WRITE(IOUT,7) J,GC(J),KR(J),HRK(J),ZRK(J),LR(J)
     1,HRL(J),ZRL(J)
   16 CONTINUE
      GO TO 19
   17 READ(IIN,4) GCZ
      DO 18 I=1,NOS
      READ(IIN,6) J,KR(J),LR(J),HRK(J),HRL(J),ZRK(J),ZRL(J)
      GC(J)=GCZ
      IF(IPNC.EQ.0) WRITE(IOUT,7) J,GC(J),KR(J),HRK(J),ZRK(J),LR(J)
     1,HRL(J),ZRL(J)
  18  CONTINUE
  19  CONTINUE
C *** (2) COMPUTE LENGTH OF BOUNDARY SIDE ***
      DO 20 J=1,NBNC
      K=KR(J)
      L=LR(J)
      TMPA=XG(K)-XG(L)
      TMPB=YG(K)-YG(L)
      DIST=CA*(TMPA*TMPA+TMPB*TMPB)**.5
C *** (3) COMPUTE LEAKAGE COEFFICIENT ***
   20 GC(J)=GC(J)*DIST
C ***
   30 IF(NPNB.LT.1) RETURN
C *** FOR NONLINEAR POINT SINKS: ***
      IF(IPNP.GT.0) GO TO 32
      WRITE(IOUT,8)
      GO TO 34
   32 WRITE(IOUT,9)
C *** (1) READ AND WRITE DATA DEFINING THE BOUNDARY ***
   34 DO 40 J=1,NPNB
      READ(IIN,10) I,KP(I),GCP,ZP(I)
      IF(IPNP.EQ.0) WRITE(IOUT,12) I,KP(I),GCP,ZP(I)
C *** (2) STORE LEAKAGE COEFFICIENT IN GC ***
      GC(I+NBNC)=GCP
   40 CONTINUE
      RETURN
      END
