


      SUBROUTINE GNPRED(H,A,B,GC,HRK,HRL,ZRK,ZRL,ZP,IN,KR,LR,KP,NBNC
     1,NPNB)
C        FORMS COEFFICIENTS FOR NONLINEAR CAUCHY-TYPE BOUNDARIES AND
C        NONLINEAR POINT SINKS; ADDS TERMS TO MATRIX EQUATION FOR THE
C        PREDICTOR
      DIMENSION H(1),A(1),B(1),GC(1),HRK(1),HRL(1),ZRK(1),ZRL(1),ZP(1)
      DIMENSION IN(1),KR(1),LR(1),KP(1)
      DIMENSION HR(2),ZR(2),NL(2)
      COMMON/NO/NELS,NNDS,NSTEPS,NPER,NZNS,NWELS,NQBND,NHDS,NEQ,MBWC,MBW
C ***
      IF(NBNC.LT.1) GO TO 50
C *** FORM COEFFICIENTS FOR EACH SIDE J ON A NONLINEAR CAUCHY-TYPE
C     BOUNDARY ***
      DO 40 J=1,NBNC
      HR(1)=HRK(J)
      HR(2)=HRL(J)
      ZR(1)=ZRK(J)
      ZR(2)=ZRL(J)
      NL(1)=KR(J)
      NL(2)=LR(J)
C *** FOR EACH NODE I ON THE BOUNDARY: ***
      DO 30 I=1,2
      L=NL(I)
      LE=IN(L)
C *** (1) BYPASS SPECIFIED-HEAD NODES ***
      IF(LE.LT.0) GO TO 30
C *** (2) COMPARE AQUIFER HEAD WITH CONTROLLING ELEVATION TO IDENTIFY
C         LEAKAGE CASE. ADD LEAKAGE COEFFICIENT TO MAIN DIAGONAL, IF
C         APPLICABLE, AND COMPUTE HEAD DIFFERENCE, TMPA, FOR RIGHT SIDE
C         FOR: ***
      IF(H(L).LT.ZR(I)) GO TO 10
      N=MBWC*(LE-1)+1
C *** CASE (1) ***
      A(N)=A(N)+GC(J)
      TMPA=HR(I)-H(L)
      GO TO 20
C *** CASE (4) ***
   10 TMPA=HR(I)-ZR(I)
C *** (3) COMPUTE RIGHT-SIDE TERM AND ADD TO B-VECTOR ***
   20 B(LE)=B(LE)+GC(J)*TMPA
   30 CONTINUE
   40 CONTINUE
C ***
   50 IF(NPNB.LT.1) RETURN
C *** FORM COEFFICIENTS FOR NONLINEAR POINT SINKS ***
C *** FOR EACH POINT I: ***
      DO 60 I=1,NPNB
      IP=I+NBNC
      K=KP(I)
      KE=IN(K)
C *** (1) BYPASS SPECIFIED-HEAD NODES ***
      IF(KE.LT.0) GO TO 60
C *** (2) COMPARE AQUIFER HEAD WITH CONTROLLING ELEVATION TO DETERMINE
C         IF LEAKAGE CASE (1) APPLIES ***
      IF(H(K).LT.ZP(I)) GO TO 60
      N=MBWC*(KE-1)+1
C *** (3) COMPUTE AND ADD TERMS TO MAIN DIAGONAL AND RIGHT SIDE ***
      A(N)=A(N)+GC(IP)
      B(KE)=B(KE)+GC(IP)*(ZP(I)-H(K))
   60 CONTINUE
      RETURN
      END
