


      SUBROUTINE INITB(TITLE,G,TIME,NBCZ)
C        READS PROBLEM SPECIFICATIONS, DEFINES AND INITIALIZES VARIABLES
C        FOR BASIC VERSION OF PROGRAM THAT USES BAND MATRIX SOLVER
      DIMENSION TITLE(20),G(1)
      COMMON/GDIM/ISUM
      COMMON/ADR/IAA,IARA,IXGA,IYGA,IATA,IQA,IBA,IHA,IHRA,IHBA,IALA,IQBA
     1,ICKA,ICLA,IHKA,IHLA,IDTA,IJPA,INA,INDA,IKA,ILA,IDZA,IDSA
      COMMON/NO/NELS,NNDS,NSTEPS,NPER,NZNS,NWELS,NQBND,NHDS,NEQ,MBWC,MBW
      COMMON/ITP/IIN,IOUT,ITA,ITB
      COMMON/BAL/SA,WQI,WQO,DQI,DQO,VLQI,VLQO,BQI,BQO,ER
      COMMON/TBAL/TSA,TWQI,TWQO,TDQI,TDQO,TLQI,TLQO,TBQI,TBQO,THBQI
     1,THBQO,TER
      COMMON/VNLBL/VNLQI,VNLQO,TNLQI,TNLQO
      COMMON/GNBL/BNQI,BNQO,TBNQI,TBNQO,PNQO,TPNQO
C *** FORMAT LIST ***
    8 FORMAT (1H1)
   10 FORMAT (20A4)
   12 FORMAT (1H ,20A4)
   14 FORMAT (16I5)
   16 FORMAT (1H0,54HNO. OF ELEMENTS (NELS).............................
     1 = ,I5/
     $1H ,54HNO. OF NODES (NNDS)................................ = ,I5/
     $1H ,54HMAX. NO. OF TIME STEPS PER STRESS PERIOD (MXSTPS).. = ,I5/
     $1H ,54HNO. OF STRESS PERIODS (NPER)....................... = ,I5/
     $1H ,54HNO. OF ZONES (NZNS)................................ = ,I5/
     $1H ,54HNO. OF POINT FLOWS (NWELS)......................... = ,I5/
     $1H ,54HNO. OF CAUCHY-TYPE BOUNDARY ELEMENT SIDES (NQBND).. = ,I5/
     $1H ,54HNO. OF CAUCHY-TYPE BOUNDARY ZONES (NBCZ)........... = ,I5/
     $1H ,54HNO. OF SPECIFIED HEADS (NHDS)...................... = ,I5/
     $1H ,54HMAXIMUM CONDENSED BAND WIDTH (MBWC)................ = ,I5/
     $1H ,54HMAXIMUM MATRIX BAND WIDTH (MBW).................... = ,I5)
   18 FORMAT (33H0DIMENSION OF G MUST BE AT LEAST ,I6)
C *** DEFINE FILE NUMBERS ***
      IIN=50
      IOUT=60
      ITA=55
      ITB=56
C *** READ AND WRITE PROBLEM TITLE ***
      WRITE(IOUT,8)
      DO 20 I=1,3
      READ(IIN,10) (TITLE(K),K=1,20)
      WRITE(IOUT,12) (TITLE(K),K=1,20)
   20 CONTINUE
C *** READ AND WRITE PROBLEM SPECIFICATIONS ***
      READ(IIN,14) NELS,NNDS,MXSTPS,NPER,NZNS,NWELS,NQBND,NBCZ,NHDS,MBWC
     1,MBW
      WRITE(IOUT,16) NELS,NNDS,MXSTPS,NPER,NZNS,NWELS,NQBND,NBCZ,NHDS
     1,MBWC,MBW
C *** DEFINE ADDRESSES OF ARRAYS WITHIN G ***
      NA=(MBWC+1)*NNDS
      NB=2*NELS
      NC=MBW*(NNDS-NHDS-MBW)+(MBW*(MBW+1))/2
      ND=(MBWC-1)*NNDS
      NE=4*NELS
      NF=NNDS-NHDS
      IF(NELS.GT.NF) NF=NELS
      ISUM=1
      IAA=ISUM
      ISUM=ISUM+NA
      IARA=ISUM
      ISUM=ISUM+NB
      INDA=ISUM
      ISUM=ISUM+NE
      IXGA=ISUM
      ISUM=ISUM+NNDS
      IYGA=ISUM
      ISUM=ISUM+NNDS
      IF(NC.GE.ISUM) ISUM=NC+1
      IATA=ISUM
      ISUM=ISUM+MBW
      IQA=ISUM
      ISUM=ISUM+NNDS
      IBA=ISUM
      ISUM=ISUM+NF
      IHA=ISUM
      ISUM=ISUM+NNDS
      IHRA=ISUM
      ISUM=ISUM+NNDS
      IHBA=ISUM
      ISUM=ISUM+NHDS
      IALA=ISUM
      ISUM=ISUM+NQBND
      IQBA=ISUM
      ISUM=ISUM+NQBND
      ICKA=ISUM
      ISUM=ISUM+NQBND
      ICLA=ISUM
      ISUM=ISUM+NQBND
      IHKA=ISUM
      ISUM=ISUM+NQBND
      IHLA=ISUM
      ISUM=ISUM+NQBND
      IDZA=ISUM
      ISUM=ISUM+NBCZ
      IDSA=ISUM
      ISUM=ISUM+NBCZ
      IDTA=ISUM
      ISUM=ISUM+MXSTPS
      IJPA=ISUM
      ISUM=ISUM+ND
      INA=ISUM
      ISUM=ISUM+NNDS+1
      IKA=ISUM
      ISUM=ISUM+NQBND
      ILA=ISUM
      ISUM=ISUM+NQBND
C *** WRITE SIZE OF G ***
      WRITE(IOUT,18) ISUM
C *** INITIALIZE G ***
      DO 30 I=1,ISUM
   30 G(I)=0.
C *** INITIALIZE TIME AND FLOW-BALANCE COMPONENTS ***
      TIME=0.
      TSA=0.
      TWQI=0.
      TWQO=0.
      TDQI=0.
      TDQO=0.
      TLQI=0.
      TLQO=0.
      TBQI=0.
      TBQO=0.
      THBQI=0.
      THBQO=0.
      PNQO=0.
      TPNQO=0.
      VNLQI=0.
      VNLQO=0.
      TNLQI=0.
      TNLQO=0.
      BNQI=0.
      BNQO=0.
      TBNQI=0.
      TBNQO=0.
      TER=0.
      RETURN
      END
