




      SUBROUTINE MASBAL(H,DHB,HR,HK,HL,QBND,CFDK,CFDL,A,Q,B,R,VQK,VQL,DT
     1,JPT,IN,KQB,LQB)
C        COMPUTES FLOW BALANCE FOR BASIC, LINEAR VERSION OF PROGRAM
      DIMENSION H(1),DHB(1),HR(1),HK(1),HL(1),QBND(1),CFDK(1),CFDL(1)
     1,A(1),Q(1),B(1),R(1),VQK(1),VQL(1)
      DIMENSION JPT(1),IN(1),KQB(1),LQB(1)
      COMMON/NO/NELS,NNDS,NSTEPS,NPER,NZNS,NWELS,NQBND,NHDS,NEQ,MBWC,MBW
      COMMON/BAL/SA,WQI,WQO,DQI,DQO,VLQI,VLQO,BQI,BQO,ER
C *** INITIALIZE FLOW-BALANCE COMPONENTS ***
      IF(NHDS.LE.0) GO TO 15
      DO 10 I=1,NHDS
   10 R(I)=0.
   15 SA=0.
      VLQI=0.
      VLQO=0.
      MBM1=MBWC-1
      IW=MBWC+1
      NC=1
      NP=0
      DTM=3./(2.*DT)
C *** COMPUTE TOTAL ACCUMULATION IN STORAGE PER UNIT TIME AND LEAKAGE
C     ACROSS AN AQUITARD PER UNIT TIME, AND ADD THESE CONTRIBUTIONS
C     AND Q INTO THE NODAL FLUX, R, AT SPECIFIED-HEAD NODES ***
      DO 90 I=1,NNDS
      NVL=NC+1
      ND=NVL
      TMPB=A(NVL)*(HR(I)-H(I))
      IF(TMPB.GT.0.) GO TO 20
      VLQO=VLQO+TMPB
      GO TO 25
   20 VLQI=VLQI+TMPB
   25 K=IN(I)
      IF(K.GT.0) GO TO 35
      K=-K
      TMPA=A(NC)*DTM*DHB(K)
      SA=SA+TMPA
      R(K)=R(K)-Q(I)+TMPA-TMPB
      DO 30 J=1,MBM1
      L=JPT(NP+J)
      IF(L.GT.NNDS) GO TO 80
      TMPA=A(ND+J)*(H(L)-H(I))
      M=-IN(L)
      IF(M.GT.0) R(M)=R(M)-TMPA
   30 R(K)=R(K)+TMPA
      GO TO 80
   35 SA=SA+A(NC)*DTM*B(K)
      DO 70 J=1,MBM1
      L=JPT(NP+J)
      IF(L.GT.NNDS) GO TO 80
      M=-IN(L)
      IF(M.GT.0) R(M)=R(M)+A(ND+J)*(H(I)-H(L))
   70 CONTINUE
   80 NC=NC+IW
   90 NP=NP+MBM1
C *** ADD HEAD-DEPENDENT FLUX INTO TOTAL INFLOW OR OUTFLOW PER UNIT TIME
C     ACROSS CAUCHY-TYPE BOUNDARIES AND INTO R ***
      BQI=0.
      BQO=0.
      IF(NQBND.LE.0) GO TO 140
      DO 130 I=1,NQBND
      TMPA=0.
      TMPB=0.
      K=KQB(I)
      IF(K.LT.0) GO TO 95
      L=LQB(I)
      M=-IN(K)
      N=-IN(L)
      TMPA=CFDK(I)*(HK(I)-H(K))
      TMPB=CFDL(I)*(HL(I)-H(L))
      IF(M.GT.0) R(M)=R(M)-TMPA
      IF(N.GT.0) R(N)=R(N)-TMPB
   95 TMPA=QBND(I)*CFDK(I)+TMPA
      VQK(I)=TMPA
      IF(TMPA.GT.0.) GO TO 100
      BQO=BQO+TMPA
      GO TO 110
  100 BQI=BQI+TMPA
  110 TMPB=QBND(I)*CFDL(I)+TMPB
      VQL(I)=TMPB
      IF(TMPB.GT.0.) GO TO 120
      BQO=BQO+TMPB
      GO TO 130
  120 BQI=BQI+TMPB
  130 CONTINUE
C *** COMPUTE TOTAL FLOW IMBALANCE PER UNIT TIME ***
  140 ER=SA-WQI-WQO-DQI-DQO-VLQI-VLQO-BQI-BQO
      RETURN
      END
