


      SUBROUTINE MASOUT(R,DT,ISTP)
C        COMPUTES TOTAL FLOW BALANCE ACROSS SPECIFIED-HEAD BOUNDARIES
C        AND WRITES TOTAL FLOW-BALANCE COMPONENTS
      DIMENSION R(1)
      COMMON/NO/NELS,NNDS,NSTEPS,NPER,NZNS,NWELS,NQBND,NHDS,NEQ,MBWC,MBW
      COMMON/ITP/IIN,IOUT,ITA,ITB
      COMMON/BAL/SA,WQI,WQO,DQI,DQO,VLQI,VLQO,BQI,BQO,ER
      COMMON/TBAL/TSA,TWQI,TWQO,TDQI,TDQO,TLQI,TLQO,TBQI,TBQO,THBQI
     1,THBQO,TER
      COMMON/VNLBL/VNLQI,VNLQO,TNLQI,TNLQO
      COMMON/GNBL/BNQI,BNQO,TBNQI,TBNQO,PNQO,TPNQO
C *** FORMAT LIST ***
    2 FORMAT (1H1,20X,21HWATER BALANCE SUMMARY/1H0,12X,35HVOLUMETRIC RAT
     1ES FOR TIME STEP NO. ,I3)
    4 FORMAT (56H ACCUMULATION OF WATER IN STORAGE.................... =
     1 ,G11.5/
     $56H RECHARGE FROM POINT SOURCES......................... = ,G11.5/
     $56H DISCHARGE FROM POINT SINKS.......................... = ,G11.5/
     $56H RECHARGE FROM DISTRIBUTED SOURCES................... = ,G11.5/
     $56H DISCHARGE FROM DISTRIBUTED SINKS.................... = ,G11.5/
     $56H RECHARGE FROM STEADY OR TRANSIENT LEAKAGE........... = ,G11.5/
     $56H DISCHARGE FROM STEADY OR TRANSIENT LEAKAGE.......... = ,G11.5/
     $56H RECHARGE ACROSS CAUCHY-TYPE BOUNDARIES.............. = ,G11.5/
     $56H DISCHARGE ACROSS CAUCHY-TYPE BOUNDARIES............. = ,G11.5/
     $56H RECHARGE ACROSS SPECIFIED-HEAD BOUNDARIES........... = ,G11.5/
     $56H DISCHARGE ACROSS SPECIFIED-HEAD BOUNDARIES.......... = ,G11.5/
     $56H DISCHARGE FROM NONLINEAR POINT SINKS................ = ,G11.5/
     $56H RECHARGE FROM NONLINEAR STEADY LEAKAGE.............. = ,G11.5/
     $56H DISCHARGE FROM NONLINEAR STEADY LEAKAGE............. = ,G11.5/
     $56H RECHARGE FROM NONLINEAR CAUCHY-TYPE BOUNDARIES...... = ,G11.5/
     $56H DISCHARGE FROM NONLINEAR CAUCHY-TYPE BOUNDARIES..... = ,G11.5/
     $56H FLOW IMBALANCE...................................... = ,G11.5)
    6 FORMAT (1H0,10X,43HTOTAL VOLUMES SINCE BEGINNING OF SIMULATION)
C *** COMPUTE TOTAL INFLOW OR OUTFLOW PER UNIT TIME ACROSS SPECIFIED-
C     HEAD BOUNDARIES ***
      HBQO=0.
      HBQI=0.
      IF(NHDS.LE.0) GO TO 170
      DO 160 I=1,NHDS
      IF(R(I).GT.0.) GO TO 150
      HBQO=HBQO+R(I)
      GO TO 160
  150 HBQI=HBQI+R(I)
  160 CONTINUE
C *** MODIFY FLOW IMBALANCE AND COMPUTE TOTAL INFLOW OR OUTFLOW
C     SINCE T=0 ACROSS SPECIFIED-HEAD BOUNDARIES ***
      ER=ER-HBQO-HBQI
      THBQO=THBQO+HBQO*DT
      THBQI=THBQI+HBQI*DT
C *** WRITE TOTAL INFLOWS AND OUTFLOWS PER UNIT TIME ***
  170 WRITE(IOUT,2) ISTP
      WRITE(IOUT,4) SA,WQI,WQO,DQI,DQO,VLQI,VLQO,BQI,BQO,HBQI,HBQO
     1,PNQO,VNLQI,VNLQO,BNQI,BNQO,ER
C *** COMPUTE TOTAL INFLOWS AND OUTFLOWS SINCE T=0 ***
      TSA=TSA+SA*DT
      TWQI=TWQI+WQI*DT
      TWQO=TWQO+WQO*DT
      TDQI=TDQI+DQI*DT
      TDQO=TDQO+DQO*DT
      TLQI=TLQI+VLQI*DT
      TLQO=TLQO+VLQO*DT
      TBQI=TBQI+BQI*DT
      TBQO=TBQO+BQO*DT
      TER=TER+ER*DT
      WRITE(IOUT,6)
C *** WRITE TOTAL INFLOWS AND OUTFLOWS SINCE T=0 ***
      WRITE(IOUT,4) TSA,TWQI,TWQO,TDQI,TDQO,TLQI,TLQO,TBQI,TBQO,THBQI
     1,THBQO,TPNQO,TNLQI,TNLQO,TBNQI,TBNQO,TER
      RETURN
      END
