


      SUBROUTINE MBWTCB(H,DH,DHB,HR,HK,HL,QBND,CFDK,CFDL,A,Q,R,VQL,THK
     1,DTK,TOP,ASY,CH,CBQ,GMA,DT,JPT,IN,KQB,LQB)
C        COMPUTES FLOW BALANCE FOR BASIC, WATER-TABLE AQUIFER VERSION OF
C        PROGRAM WITH TRANSIENT LEAKAGE
      DIMENSION H(1),DH(1),DHB(1),HR(1),HK(1),HL(1),QBND(1),CFDK(1)
     1,CFDL(1),A(1),Q(1),R(1),VQL(1),THK(1),DTK(1),TOP(1),ASY(1),CH(1)
     2,CBQ(1),GMA(1)
      DIMENSION JPT(1),IN(1),KQB(1),LQB(1)
      COMMON/NO/NELS,NNDS,NSTEPS,NPER,NZNS,NWELS,NQBND,NHDS,NEQ,MBWC,MBW
      COMMON/BAL/SA,WQI,WQO,DQI,DQO,VLQI,VLQO,BQI,BQO,ER
C *** COMPUTE DTK-VECTOR, AND COMPUTE CAPACITANCE AT STORAGE CONVERSION
C     NODES ***
      WF=2./3.
      NC=1
      IW=MBWC+1
      DO 14 I=1,NNDS
      DTK(I)=0.
      J=IN(I)
      IF(J.GT.0) GO TO 2
      DHC=DHB(-J)
      GO TO 4
    2 DHC=DH(J)
    4 HO=H(I)-DHC
      DHC=1.5*DHC
      HC=HO+DHC
      IF(HO.LT.TOP(I)) GO TO 6
      IF(HC.GE.TOP(I)) GO TO 14
      DTK(I)=HC-TOP(I)
      IF(THK(I)+DTK(I).LT.0.) DTK(I)=-THK(I)
      THET=(TOP(I)-HO)/DHC
      A(NC)=THET*(A(NC)-ASY(I))+ASY(I)
      GO TO 12
    6 IF(HC.LT.TOP(I)) GO TO 8
      DTK(I)=TOP(I)-HO
      THET=DTK(I)/DHC
      A(NC)=THET*(ASY(I)-A(NC))+A(NC)
      GO TO 12
    8 IF(THK(I)+DHC.GT.0.) GO TO 10
      DTK(I)=0.
      IF(THK(I).GT.0.) DTK(I)=-THK(I)
      GO TO 11
   10 DTK(I)=DHC
      IF(THK(I).LT.0.) DTK(I)=DHC+THK(I)
   11 A(NC)=ASY(I)
   12 DTK(I)=WF*DTK(I)
   14 NC=NC+IW
C *** INITIALIZE FLOW-BALANCE COMPONENTS ***
      IF(NHDS.LE.0) GO TO 18
      DO 16 I=1,NHDS
   16 R(I)=0.
   18 SA=0.
      VLQI=0.
      VLQO=0.
      C=1./16.
      MBM1=MBWC-1
      NC=1
      NP=0
      N=0
      DTM=3./(2.*DT)
C *** COMPUTE TOTAL ACCUMULATION IN STORAGE PER UNIT TIME AND LEAKAGE
C     ACROSS AN AQUITARD PER UNIT TIME, AND ADD THESE CONTRIBUTIONS
C     AND Q INTO THE NODAL FLUX, R, AT SPECIFIED-HEAD NODES ***
      DO 90 I=1,NNDS
      NVL=NC+1
      ND=NVL
      TMPB=A(NVL)*(HR(I)-H(I))
      THKI=THK(I)
      IF(THKI.LT.0.) THKI=0.
      K=IN(I)
      IF(K.GT.0) GO TO 35
      K=-K
      TMPA=A(NC)*DTM*DHB(K)
      SA=SA+TMPA
      IF(GMA(I).LT.1.E-30) GO TO 20
      N=N+1
      TMPB=TMPB+CBQ(N)-CH(N)*DHB(K)
   20 R(K)=R(K)-Q(I)+TMPA-TMPB
      DO 30 J=1,MBM1
      L=JPT(NP+J)
      M=IN(L)
      IF(M) 26,75,28
   26 THKL=THK(L)
      IF(THKL.LT.0.) THKL=0.
      M=-M
      TMPA=(.5*(DTK(I)+DTK(L)+THKI+THKL)*(H(L)-H(I))
     1+C*(DTK(I)+DTK(L))*(DHB(M)-DHB(K)))*A(ND+J)
      R(K)=R(K)+TMPA
      R(M)=R(M)-TMPA
      GO TO 30
   28 THKL=THK(L)
      IF(THKL.LT.0.) THKL=0.
      R(K)=R(K)+(.5*(DTK(I)+DTK(L)+THKI+THKL)*(H(L)-H(I))
     1+C*(DTK(I)+DTK(L))*(DH(M)-DHB(K)))*A(ND+J)
   30 CONTINUE
      GO TO 75
   35 SA=SA+A(NC)*DTM*DH(K)
      IF(GMA(I).LT.1.E-30) GO TO 40
      N=N+1
      TMPB=TMPB+CBQ(N)-CH(N)*DH(K)
   40 DO 70 J=1,MBM1
      L=JPT(NP+J)
      M=IN(L)
      IF(M) 60,75,70
   60 M=-M
      THKL=THK(L)
      IF(THKL.LT.0.) THKL=0.
      R(M)=R(M)+(.5*(DTK(I)+DTK(L)+THKI+THKL)*(H(I)-H(L))
     1+C*(DTK(I)+DTK(L))*(DH(K)-DHB(M)))*A(ND+J)
   70 CONTINUE
   75 IF(TMPB.GT.0.) GO TO 80
      VLQO=VLQO+TMPB
      GO TO 85
   80 VLQI=VLQI+TMPB
   85 NC=NC+IW
   90 NP=NP+MBM1
C *** ADD HEAD-DEPENDENT FLUX INTO TOTAL INFLOW OR OUTFLOW PER UNIT
C     TIME ACROSS CAUCHY-TYPE BOUNDARIES AND INTO R ***
      BQI=0.
      BQO=0.
      IF(NQBND.LE.0) GO TO 140
      DO 130 I=1,NQBND
      TMPA=0.
      TMPB=0.
      K=KQB(I)
      IF(K.LT.0) GO TO 95
      L=LQB(I)
      M=-IN(K)
      N=-IN(L)
      TMPA=CFDK(I)*(HK(I)-H(K))
      TMPB=CFDL(I)*(HL(I)-H(L))
      IF(M.GT.0) R(M)=R(M)-TMPA
      IF(N.GT.0) R(N)=R(N)-TMPB
   95 TMPA=QBND(I)*CFDK(I)+TMPA
      DTK(I)=TMPA
      IF(TMPA.GT.0.) GO TO 100
      BQO=BQO+TMPA
      GO TO 110
  100 BQI=BQI+TMPA
  110 TMPB=QBND(I)*CFDL(I)+TMPB
      VQL(I)=TMPB
      IF(TMPB.GT.0.) GO TO 120
      BQO=BQO+TMPB
      GO TO 130
  120 BQI=BQI+TMPB
  130 CONTINUE
C *** COMPUTE TOTAL FLOW IMBALANCE PER UNIT TIME ***
  140 ER=SA-WQI-WQO-DQI-DQO-VLQI-VLQO-BQI-BQO
      RETURN
      END
