


      SUBROUTINE MICCG(A,AF,X,P,R,B,TOL,JPT,IN)
C        SOLVES MATRIX EQUATION FOR HEAD CHANGE VECTOR, B, BY USING
C        THE MODIFIED, INCOMPLETE CHOLESKY, CONJUGATE GRADIENT METHOD
      DIMENSION A(1),AF(1),X(1),P(1),R(1),B(1)
      DIMENSION JPT(1),IN(1)
      COMMON/NO/NELS,NNDS,NSTEPS,NPER,NZNS,NWELS,NQBND,NHDS,NEQ,MBWC,NIT
      COMMON/ITP/IIN,IOUT,ITA,ITB
C *** FORMAT LIST ***
    2 FORMAT (23H0SOLUTION CONVERGED IN ,I4,11H ITERATIONS)
    4 FORMAT (32H0SOLUTION FAILED TO CONVERGE IN ,I4,11H ITERATIONS
     1,3X,7HRMAX = ,G11.5)
    6 FORMAT (1H0,14X,42HCURRENT VALUES OF CHANGE IN HYDRAULIC HEAD
     1/1H ,3(6H  NODE,8X,4HHEAD,7X))
      N=NNDS-NHDS
      MBM1=MBWC-1
C *** COMPUTE AUGMENTATION FACTOR, IF NEEDED, FOR DIAGONAL ELEMENTS OF
C     AF MATRIX, WHICH IS THE MATRIX TO BE FACTORED ***
      DEL=.9993333
   10 DEL=1.5*DEL-.499
C *** DEFINE AF MATRIX AS THE A MATRIX WITH THE DIAGONALS AUGMENTED
C     IF NECESSARY ***
      ID=1
      DO 20 I=1,N
      IF(A(ID).GT.1.E-20) GO TO 12
      A(ID)=1.E30
      B(I)=0.
   12 AF(ID)=DEL*A(ID)
      DO 15 J=1,MBM1
   15 AF(ID+J)=A(ID+J)
   20 ID=ID+MBWC
      NEM1=NEQ-1
C *** BEGIN FACTORIZATION OF AF INTO SPARSE PRODUCT OF UPPER TRIANGULAR,
C     DIAGONAL, AND LOWER TRIANGULAR MATRICES, ALL KEPT IN AF ***
      NP=0
      ID=1
      DO 90 I=1,NEM1
      IF(IN(I).LT.0) GO TO 90
C *** DEFINE PIVOT ***
      IF(AF(ID).LE.0.) GO TO 10
      PIV=1./AF(ID)
      DO 70 J=1,MBM1
      KJ=JPT(NP+J)
      K=IN(KJ)
      IF(K) 70,80,25
   25 KD=MBWC*(K-1)+1
C *** DEFINE ROW MULTIPLIER ***
      C=AF(ID+J)*PIV
C *** REDUCE DIAGONAL OF AF ***
      AF(KD)=AF(KD)-C*AF(ID+J)
      LBG=J+1
      IF(LBG.GT.MBM1) GO TO 60
      KJ=MBM1*(KJ-1)
      MBG=1
      DO 50 L=LBG,MBM1
      KL=JPT(NP+L)
      IF(IN(KL)) 50,60,30
   30 TMPA=C*AF(ID+L)
C *** SEARCH TO DETERMINE IF NODE KL LIES IN THE ROW BEING REDUCED ***
      DO 40 M=MBG,MBM1
      MS=M
      IF(JPT(KJ+M).EQ.KL) GO TO 45
   40 CONTINUE
C *** REDUCE APPROPRIATE DIAGONAL ELEMENTS BY SUBTRACTING FILL-IN IF
C     KL IS NOT IN THE ROW BEING REDUCED ***
      AF(KD)=AF(KD)-TMPA
      LD=MBWC*(IN(KL)-1)+1
      AF(LD)=AF(LD)-TMPA
      GO TO 50
C *** REDUCE OFF-DIAGONAL IF KL IS IN THE ROW BEING REDUCED ***
   45 AF(KD+MS)=AF(KD+MS)-TMPA
      MBG=MS
   50 CONTINUE
   60 AF(ID+J)=C
   70 CONTINUE
   80 ID=ID+MBWC
   90 NP=NP+MBM1
      IF(AF(ID).LE.0.) GO TO 10
C *** DEFINE INITIAL RESIDUAL VECTOR, R, AS THE RIGHT-HAND-SIDE VECTOR,
C     B, OF THE ORIGINAL MATRIX EQUATION, THEN ZERO OUT INITIAL HEAD
C     CHANGE VECTOR, B ***
      DO 95 I=1,N
      R(I)=B(I)
   95 B(I)=0.
C *** BEGIN CONJUGATE GRADIENT ITERATION LOOP ***
      DO 270 KNT=1,NIT
      IT=KNT
C *** READ RESIDUAL VECTOR, R, INTO X ***
      DO 100 I=1,N
  100 X(I)=R(I)
C *** REDUCE RESIDUAL VECTOR, X ***
      ID=1
      NP=0
      DO 130 I=1,NEM1
      M=IN(I)
      IF(M.LT.0) GO TO 130
      DO 110 J=1,MBM1
      K=JPT(NP+J)
      K=IN(K)
      IF(K) 110,120,105
  105 X(K)=X(K)-AF(ID+J)*X(M)
  110 CONTINUE
  120 X(M)=X(M)/AF(ID)
      ID=ID+MBWC
  130 NP=NP+MBM1
C *** BACK-SOLVE FOR FIRST-ORDER DISPLACEMENT VECTOR, X ***
      X(N)=X(N)/AF(ID)
      K=NEQ
      DO 150 I=1,NEM1
      NP=NP-MBM1
      K=K-1
      M=IN(K)
      IF(M.LT.0) GO TO 150
      ID=ID-MBWC
      DO 140 J=1,MBM1
      L=JPT(NP+J)
      L=IN(L)
      IF(L) 140,150,135
  135 X(M)=X(M)-AF(ID+J)*X(L)
  140 CONTINUE
  150 CONTINUE
C *** FORM INNER PRODUCT OF RESIDUAL AND X VECTORS ***
      RX=0.
      DO 160 I=1,N
  160 RX=RX+R(I)*X(I)
      IF(IT.EQ.1) GO TO 180
C *** COMPUTE ITERATION PARAMETER, BETA ***
      S=RX/RXO
C *** COMPUTE SECOND-ORDER DISPLACEMENT VECTOR, P ***
      DO 170 I=1,N
  170 P(I)=X(I)+S*P(I)
      GO TO 200
  180 DO 190 I=1,N
  190 P(I)=X(I)
  200 DO 210 I=1,N
  210 X(I)=0.
C *** COMPUTE PRODUCT OF MATRIX A AND VECTOR P, AND KEEP PRODUCT
C     IN X ***
      ID=1
      NP=0
      DO 240 I=1,NEQ
      M=IN(I)
      IF(M.LT.0) GO TO 240
      X(M)=X(M)+A(ID)*P(M)
      DO 220 J=1,MBM1
      K=JPT(NP+J)
      K=IN(K)
      IF(K) 220,230,215
  215 X(M)=X(M)+A(ID+J)*P(K)
      X(K)=X(K)+A(ID+J)*P(M)
  220 CONTINUE
  230 ID=ID+MBWC
  240 NP=NP+MBM1
C *** FORM INNER PRODUCT OF P AND X VECTORS ***
      PX=0.
      DO 250 I=1,N
  250 PX=PX+P(I)*X(I)
C *** COMPUTE ITERATION PARAMETER, ALPHA ***
      W=1.
      IF(PX.GT.0.) W=RX/PX
C *** COMPUTE NEW HEAD CHANGE VECTOR, B, AND NEW RESIDUAL VECTOR, R,
C     THEN TEST FOR CONVERGENCE ***
      PMAX=0.
      RMAX=0.
      ID=1
      DO 260 I=1,N
      TMPA=W*P(I)
      B(I)=B(I)+TMPA
      R(I)=R(I)-W*X(I)
      TMPA=ABS(TMPA)
      IF(TMPA.GT.PMAX) PMAX=TMPA
      TMPA=ABS(R(I)/A(ID))
      IF(TMPA.GT.RMAX) RMAX=TMPA
  260 ID=ID+MBWC
      IF(PMAX.LE.TOL.AND.RMAX.LE.TOL) GO TO 280
      RXO=RX
  270 CONTINUE
C *** WRITE MAXIMUM SCALED RESIDUAL AND CURRENT HEAD CHANGE VECTOR IF
C     SOLUTION DID NOT CONVERGE ***
      WRITE(IOUT,4) NIT,RMAX
      WRITE(IOUT,6)
      CALL PRTOA(B,N)
      STOP
C *** WRITE NUMBER OF ITERATIONS IF SOLUTION CONVERGED ***
  280 WRITE(IOUT,2) IT
      RETURN
      END
