

C        *** NLMFE3 ***
C        MODULAR FINITE-ELEMENT MODEL OF GROUND-WATER FLOW
C        IN TWO DIMENSIONS.
C        SIMULATES THE FOLLOWING CONDITIONS:
C        (1) UNCONFINED FLOW
C        (2) AQUIFER STORAGE CONVERSIONS
C        (3) TRANSIENT LEAKAGE
C        USES DIRECT METHOD OF TRIANGULAR DECOMPOSITION
C        TO SOLVE MATRIX EQUATIONS.
      DIMENSION TITLE(20)
      COMMON/PRIME/G(5000)
      COMMON/GDIM/ISUM
      COMMON/ADR/IAA,IARA,IXGA,IYGA,IATA,IQA,IBA,IHA,IHRA,IHBA,IALA,IQBA
     1,ICKA,ICLA,IHKA,IHLA,IDTA,IJPA,INA,INDA,IKA,ILA,IDZA,IDSA
      COMMON/NO/NELS,NNDS,NSTEPS,NPER,NZNS,NWELS,NQBND,NHDS,NEQ,MBWC,MBW
      COMMON/CHG/NWCH,NQCH,NHRCH,NBQCH,NHCH,NCBCH,NVNCH,NGNCH
      COMMON/ITP/IIN,IOUT,ITA,ITB
      COMMON/IPRN/IPND
      COMMON/IND/IRAD,IUNIT,ISTD
      COMMON/SCLE/SCALE
      COMMON/BAL/SA,WQI,WQO,DQI,DQO,VLQI,VLQO,BQI,BQO,ER
      COMMON/TBAL/TSA,TWQI,TWQO,TDQI,TDQO,TLQI,TLQO,TBQI,TBQO,THBQI
     1,THBQO,TER
      COMMON/VNLBL/VNLQI,VNLQO,TNLQI,TNLQO
      COMMON/GNBL/BNQI,BNQO,TBNQI,TBNQO,PNQO,TPNQO
C
C     set string for use if RCS ident command
      CHARACTER*80 vr
      vr =
     &'$Id: nlmfe3.main.f,v 1.2 1995/08/08 16:31:11 rsregan Exp $'
C     set string for use with UNIX what command
      vr = '@(#)MODFE - MODular Finite-Element ground-water flow model'
      vr = '@(#)MODFE - USGS TWRI Book 6, Chapter A3, 1993 L.J. Torak'
      vr = '@(#)MODFE - USGS TWRI Book 6, Chapter A4, 1992, R.L. Cooley'
      vr = '@(#)MODFE - USGS TWRI Book 6, Chapter A5, 1993 L.J. Torak'
      vr = '@(#)MODFE - Contact: h2osoft@usgs.gov'
      vr = '@(#)MODFE - Version: 1.2x 1995/08/08'
C
      OPEN (50,FILE='MODFE.DAT',STATUS='OLD',ACCESS='SEQUENTIAL'
     1,FORM='FORMATTED')
      OPEN (60,FILE='MODFE.OUT',STATUS='NEW',ACCESS='SEQUENTIAL'
     1,FORM='FORMATTED')
      OPEN (55,STATUS='SCRATCH',ACCESS='SEQUENTIAL',FORM='UNFORMATTED')
      OPEN (56,STATUS='SCRATCH',ACCESS='SEQUENTIAL',FORM='UNFORMATTED')
    6 FORMAT(/9X,49HSUMMARY OF FLOW AT CAUCHY-TYPE BOUNDARIES BY ZONE)
      CALL INITB(TITLE,G,TIME,NBCZ)
      CALL WTINIT(G,IDHA,ITKA,ITPA,ISYA)
      CALL CBINIT(G,ICHA,ICQA,IDHRA,ICTQA,IGMA,IALFA,IACA,IBTA,IBCA
     1,NCBZ)
      CALL DATIN(TITLE,G(IXGA),G(IYGA),G(IHA),G(IHBA),G(IHRA)
     1,G(IHKA),G(IHLA),G(IALA),G(IQBA),G(IQA),G(IKA),G(ILA),G(INA)
     2,G(IDZA),G(IDSA),NBCZ)
      CALL FMCO(G(IXGA),G(IYGA),G(IAA),G(IQA),G(IARA),G(IALA),G(IQBA)
     1,G(ICKA),G(ICLA),G(INDA),G(IBA),G(IJPA),G(IKA),G(ILA))
      CALL WTFMCO(G(IARA),G(ITKA),G(ITPA),G(ISYA),G(INDA))
      CALL CBFMCO(G(IAA),G(IARA),G(IGMA),G(IALFA),G(IACA),G(IBTA)
     1,G(IBCA),G(IYGA),G(INDA),NCBZ)
      CALL SETB(G(IAA),G(INA),G(INDA),IBND)
      DO 20 JP=1,NPER
      JPER=JP
      CALL NXTPD(G(IDTA),JPER)
      DO 10 I=1,NSTEPS
      ISTP=I
      DT=G(IDTA+I-1)
      CALL COCHG(G(IQA),G(IARA),G(IHA),G(IHRA),G(IHBA),G(IHKA),G(IHLA)
     1,G(IALA),G(IQBA),G(ICKA),G(ICLA),TIME,G(IKA),G(ILA),G(INDA),G(INA)
     2,ISTP)
      IF(NCBCH.EQ.ISTP) CALL CBCHG(G(IHRA),G(IDHRA),TIME,ISTP)
      CALL RDTP(G(IAA))
      CALL CBFMEQ(G(IAA),G(ICHA),G(ICQA),G(IDHRA),G(ICTQA),G(IGMA)
     1,G(IALFA),G(IACA),G(IBTA),G(IBCA),DT,G(INA))
      CALL FMEPWT(G(IHA),G(IHRA),G(IHKA),G(IHLA),G(ICKA),G(ICLA),G(IAA)
     1,G(IARA),G(IQA),G(IBA),G(ITKA),G(ITPA),G(ISYA),DT,G(IJPA),G(INA)
     2,G(IKA),G(ILA))
      CALL CBADEQ(G(IAA),G(IBA),G(ICHA),G(ICQA),G(IGMA),G(INA))
      CALL BAND(G(IAA),G(IATA),G(IBA),G(IJPA),G(INA),IBND)
      CALL HCALWT(G(IHA),G(IDHA),G(IBA),G(INA))
      CALL RDTP(G(IAA))
      CALL FMECWT(G(IHA),G(IDHA),G(IHBA),G(IHRA),G(IHKA),G(IHLA),G(ICKA)
     1,G(ICLA),G(IAA),G(IARA),G(IQA),G(IBA),G(ITKA),G(IYGA),G(ITPA)
     2,G(ISYA),DT,G(IJPA),G(INA),G(IKA),G(ILA))
      CALL CBADWT(G(IDHA),G(IAA),G(IBA),G(ICHA),G(ICQA),G(IGMA),G(INA))
      CALL BAND(G(IAA),G(IATA),G(IBA),G(IJPA),G(INA),IBND)
      CALL WTCCHK(G(IHA),G(IDHA),G(IBA),G(ITPA),G(INA),ISC)
      IF(ISC.EQ.0) GO TO 5
      CALL HCALWT(G(IHA),G(IDHA),G(IBA),G(INA))
      CALL RDTP(G(IAA))
      CALL FMECWT(G(IHA),G(IDHA),G(IHBA),G(IHRA),G(IHKA),G(IHLA),G(ICKA)
     1,G(ICLA),G(IAA),G(IARA),G(IQA),G(IBA),G(ITKA),G(IYGA),G(ITPA)
     2,G(ISYA),DT,G(IJPA),G(INA),G(IKA),G(ILA))
      CALL CBADWT(G(IDHA),G(IAA),G(IBA),G(ICHA),G(ICQA),G(IGMA),G(INA))
      CALL BAND(G(IAA),G(IATA),G(IBA),G(IJPA),G(INA),IBND)
    5 CALL HCALWT(G(IHA),G(IDHA),G(IBA),G(INA))
      CALL RDTP(G(IAA))
      CALL MBWTCB(G(IHA),G(IDHA),G(IHBA),G(IHRA),G(IHKA),G(IHLA)
     1,G(IQBA),G(ICKA),G(ICLA),G(IAA),G(IQA),G(IYGA),G(IXGA),G(ITKA)
     2,G(IARA),G(ITPA),G(ISYA),G(ICHA),G(ICQA),G(IGMA),DT,G(IJPA)
     3,G(INA),G(IKA),G(ILA))
      CALL CBTQC(G(IDHA),G(IHBA),G(ICTQA),G(IGMA),G(IALFA),G(IACA)
     1,DT,G(INA))
      IF(ISTD.LT.1) CALL XTRPWT(G(IHA),G(IDHA),G(IHBA),G(ITKA),G(ITPA)
     1,G(INA),ISTP)
      CALL CBHRXT(G(IHRA),G(IDHRA))
      CALL DATOUT(G(IHA),DT,TIME,ISTP)
      IF(NQBND.LT.1) GO TO 8
      WRITE(IOUT,6)
      CALL PRTCBV(G(IARA),G(IXGA),DT,G(IKA),G(ILA),G(IDZA),G(IDSA),NBCZ)
    8 CALL MASOUT(G(IYGA),DT,ISTP)
   10 CONTINUE
   20 CONTINUE
      STOP
      END
