

C        *** NSSFE4 COMBINED WITH NSSFE6 ***
C        MODULAR FINITE-ELEMENT MODEL OF GROUND-WATER FLOW
C        IN TWO DIMENSIONS.
C        SIMULATES THE FOLLOWING CONDITIONS:
C        (1) UNCONFINED, STEADY-STATE FLOW
C        (2) NONLINEAR STEADY LEAKAGE
C        (3) NONLINEAR CAUCHY-TYPE BOUNDARIES
C        USES DIRECT METHOD OF TRIANGULAR DECOMPOSITION
C        TO SOLVE MATRIX EQUATIONS.
      DIMENSION TITLE(20)
      COMMON/PRIME/G(5000)
      COMMON/GDIM/ISUM
      COMMON/ADR/IAA,IARA,IXGA,IYGA,IATA,IQA,IBA,IHA,IHRA,IHBA,IALA,IQBA
     1,ICKA,ICLA,IHKA,IHLA,IDTA,IJPA,INA,INDA,IKA,ILA,IDZA,IDSA
      COMMON/NO/NELS,NNDS,NSTEPS,NPER,NZNS,NWELS,NQBND,NHDS,NEQ,MBWC,NIT
      COMMON/CHG/NWCH,NQCH,NHRCH,NBQCH,NHCH,NCBCH,NVNCH,NGNCH
      COMMON/ITP/IIN,IOUT,ITA,ITB
      COMMON/IPRN/IPND
      COMMON/IND/IRAD,IUNIT,ISTD
      COMMON/SCLE/SCALE
      COMMON/BAL/SA,WQI,WQO,DQI,DQO,VLQI,VLQO,BQI,BQO,ER
      COMMON/TBAL/TSA,TWQI,TWQO,TDQI,TDQO,TLQI,TLQO,TBQI,TBQO,THBQI
     1,THBQO,TER
      COMMON/VNLBL/VNLQI,VNLQO,TNLQI,TNLQO
      COMMON/GNBL/BNQI,BNQO,TBNQI,TBNQO,PNQO,TPNQO
C
C     set string for use if RCS ident command
      CHARACTER*80 vr
      vr =
     &'$Id: nssfe4.nssfe6.main.f,v 1.2 1995/08/08 16:31:11 rsregan $'
C     set string for use with UNIX what command
      vr = '@(#)MODFE - MODular Finite-Element ground-water flow model'
      vr = '@(#)MODFE - USGS TWRI Book 6, Chapter A3, 1993 L.J. Torak'
      vr = '@(#)MODFE - USGS TWRI Book 6, Chapter A4, 1992, R.L. Cooley'
      vr = '@(#)MODFE - USGS TWRI Book 6, Chapter A5, 1993 L.J. Torak'
      vr = '@(#)MODFE - Contact: h2osoft@usgs.gov'
      vr = '@(#)MODFE - Version: 1.2x 1995/08/08'
C
      OPEN (50,FILE='MODFE.DAT',STATUS='OLD',ACCESS='SEQUENTIAL'
     1,FORM='FORMATTED')
      OPEN (60,FILE='MODFE.OUT',STATUS='NEW',ACCESS='SEQUENTIAL'
     1,FORM='FORMATTED')
      OPEN (55,STATUS='SCRATCH',ACCESS='SEQUENTIAL',FORM='UNFORMATTED')
      OPEN (56,STATUS='SCRATCH',ACCESS='SEQUENTIAL',FORM='UNFORMATTED')
   10 FORMAT (1H1,18X,30HSUMMARY OF CLOSURE INFORMATION/
     $56H NO. OF ITERATIONS TO CLOSE (ITER) .................. = ,I4/
     $56H MAXIMUM ABSOLUTE DISPLACEMENT (DSPA) ............... = ,G11.5)
   20 FORMAT(/9X,49HSUMMARY OF FLOW AT CAUCHY-TYPE BOUNDARIES BY ZONE)
   22 FORMAT(/4X,'SUMMARY OF FLOW AT NONLINEAR CAUCHY-TYPE BOUNDARIES',
     1' BY ZONE')
      CALL INITB(TITLE,G,TIME,NBCZ)
      CALL SWINIT(G,TOLSW,DSMX,DSP,RP,NITSW,ITKA,ITPA)
      CALL GNINIT(G,IGCA,IHRK,IHRL,IZRK,IZRL,IZPA,IKRA,ILRA,IKPA,INZA
     1,INSA,NBNC,NPNB,NLCZ)
      CALL VNINIT(G,IECA,IHSA,NVNZ)
      CALL DATIN(TITLE,G(IXGA),G(IYGA),G(IHA),G(IHBA),G(IHRA)
     1,G(IHKA),G(IHLA),G(IALA),G(IQBA),G(IQA),G(IKA),G(ILA),G(INA)
     2,G(IDZA),G(IDSA),NBCZ)
      CALL FMCO(G(IXGA),G(IYGA),G(IAA),G(IQA),G(IARA),G(IALA),G(IQBA)
     1,G(ICKA),G(ICLA),G(INDA),G(IBA),G(IJPA),G(IKA),G(ILA))
      CALL SETB(G(IAA),G(INA),G(INDA),IBND)
      CALL SWFMCO(G(IAA),G(ITKA),G(ITPA),G(IJPA),G(INA))
      CALL GNFMCO(G(IXGA),G(IYGA),G(IGCA),G(IHRK),G(IHRL),G(IZRK)
     1,G(IZRL),G(IZPA),G(IKRA),G(ILRA),G(IKPA),G(INZA),G(INSA),NBNC
     2,NPNB,NLCZ)
      CALL VNFMCO(G(IHA),G(IARA),G(IECA),G(IHSA),G(INDA),NVNZ)
      ISTP=1
      DT=1.
      DO 50 IT=1,NITSW
      ITER=IT
      CALL FMEQ(G(IHA),G(IHRA),G(IHKA),G(IHLA),G(ICKA),G(ICLA)
     1,G(IAA),G(IARA),G(IQA),G(IBA),DT,G(IJPA),G(INA),G(IKA),G(ILA))
      CALL GNPRED(G(IHA),G(IAA),G(IBA),G(IGCA),G(IHRK),G(IHRL),G(IZRK)
     1,G(IZRL),G(IZPA),G(INA),G(IKRA),G(ILRA),G(IKPA),NBNC,NPNB)
      CALL VNPRED(G(IHA),G(IAA),G(IBA),G(ITPA),G(IECA),G(IHSA),G(INA))
      CALL BAND(G(IAA),G(IATA),G(IBA),G(IJPA),G(INA),IBND)
      CALL SWBDMP(G(IBA),DSMX,DSP,DSPO,DSPA,RP,ITER)
      CALL HCALC(G(IHA),G(IBA),G(INA))
      CALL RDTP(G(IAA))
      CALL SWTHK(G(IHA),G(IAA),G(IBA),G(IQA),G(ITKA),G(ITPA),DSPA,TOLSW
     1,G(IJPA),G(INA),ITER)
      IF(DSPA.LT.TOLSW) GO TO 60
   50 CONTINUE
   60 CALL MASBAL(G(IHA),G(IHBA),G(IHRA),G(IHKA),G(IHLA),G(IQBA),G(ICKA)
     1,G(ICLA),G(IAA),G(IQA),G(IBA),G(IYGA),G(IARA),G(IXGA),DT,G(IJPA)
     2,G(INA),G(IKA),G(ILA))
      IF(NQBND.LT.1) GO TO 62
      WRITE(IOUT,20)
      CALL PRTCBV(G(IARA),G(IXGA),DT,G(IKA),G(ILA),G(IDZA),G(IDSA),NBCZ)
   62 CALL GNBLSS(G(IHA),G(IYGA),G(IGCA),G(IHRK),G(IHRL),G(IZRK),G(IZRL)
     1,G(IZPA),G(IARA),G(IXGA),DT,G(INA),G(IKRA),G(ILRA),G(IKPA),NBNC
     2,NPNB)
      IF(NLCZ.LT.1) GO TO 64
      WRITE(IOUT,22)
      CALL PRTCBV(G(IARA),G(IXGA),DT,G(IKRA),G(ILRA),G(INZA),G(INSA)
     1,NLCZ)
   64 CALL VNBLSS(G(IHA),G(IYGA),G(ITPA),G(IECA),G(IHSA),DT,G(INA))
      WRITE(IOUT,10) ITER,DSPA
      CALL DATOUT(G(IHA),DT,TIME,ISTP)
      CALL TKOUT(G(ITKA))
      CALL MASOUT(G(IYGA),DT,ISTP)
      STOP
      END
