
      SUBROUTINE PRTCBV(VALA,VALB,DT,NVLA,NVLB,INZ,INS,NBZ)
C        PRINTS OUT NODAL VOLUMETRIC FLOW RATES FROM (NONLINEAR) CAUCHY-
C        TYPE BOUNDARIES AND SUMS NODAL RATES BY ZONE.  FLOW RATES FOR
C        NODES K AND L ON BOUNDARIES ARE STORED IN TWO VECTORS, WHICH
C        ARE WRITTEN OUT FOR EACH BOUNDARY SIDE.
      DIMENSION VALA(1),VALB(1)
      DIMENSION NVLA(1),NVLB(1),INZ(1),INS(1)
      COMMON/ITP/IIN,IOUT,ITA,ITB
   20 FORMAT(1H0,5HZONE ,I5/
     $56H VOLUMETRIC RECHARGE RATE............................ = ,G11.5/
     $56H VOLUMETRIC DISCHARGE RATE........................... = ,G11.5/
     $56H TOTAL RECHARGE VOLUME............................... = ,G11.5/
     $56H TOTAL DISCHARGE VOLUME.............................. = ,G11.5/
     $56H NET VOLUMETRIC FLOW RATE, POSITIVE FOR RECHARGE..... = ,G11.5/
     $56H NET VOLUME, POSITIVE FOR ACCUMULATION............... = ,G11.5)
   22 FORMAT(/1H0,4X
     1,48HVOLUMETRIC FLOW RATES BY BOUNDARY SIDE FOR ZONE ,I5/
     2/1H ,4X,8HBOUNDARY,4X,4HNODE,4X,4HNODE,5X,21HVOLUMETRIC FLOW RATES
     3/1H ,6X,4HSIDE,8X,1HK,7X,1HL,6X,6HNODE K,9X,6HNODE L)
   24 FORMAT(' ',4X,I5,6X,I5,3X,I5,2(4X,G11.5))
      J=0
      JB=1
      DO 150 NZ=1,NBZ
      KZ=INZ(NZ)
      NOS=INS(KZ)
      SMQI=0.
      SMQO=0.
      SMVI=0.
      SMVO=0.
      QNET=0.
      VNET=0.
      DO 130 I=1,NOS
      J=J+1
      VQK=VALA(J)
      VQL=VALB(J)
      IF(VQK.GT.0.) GO TO 100
      SMQO=SMQO+VQK
      GO TO 110
  100 SMQI=SMQI+VQK
  110 IF(VQL.GT.0.) GO TO 120
      SMQO=SMQO+VQL
      GO TO 130
  120 SMQI=SMQI+VQL
  130 CONTINUE
      SMVI=SMQI*DT
      SMVO=SMQO*DT
      QNET=SMQI+SMQO
      VNET=SMVI+SMVO
      WRITE(IOUT,20) KZ,SMQI,SMQO,SMVI,SMVO,QNET,VNET
      WRITE(IOUT,22) KZ
      L=JB
      DO 145 I=1,NOS
      NVA=NVLA(L)
      IF(NVA.LT.0) NVA=-NVA
      WRITE(IOUT,24) L,NVA,NVLB(L),VALA(L),VALB(L)
  145 L=L+1
      JB=L
  150 CONTINUE
      RETURN
      END
