


      SUBROUTINE VNBLSS(H,R,TOP,E,HS,DT,IN)
C        COMPUTES FLOW-BALANCE COMPONENTS FOR NONLINEAR STEADY-LEAKAGE
C        FUNCTIONS FOR STEADY-STATE SIMULATIONS
      DIMENSION H(1),R(1),TOP(1),E(1),HS(1)
      DIMENSION IN(1)
      COMMON/NO/NELS,NNDS,NSTEPS,NPER,NZNS,NWELS,NQBND,NHDS,NEQ,MBWC,MBW
      COMMON/BAL/SA,WQI,WQO,DQI,DQO,VLQI,VLQO,BQI,BQO,ER
      COMMON/VNLBL/VNLQI,VNLQO,TNLQI,TNLQO
C *** INITIALIZE VOLUMETRIC FLOW RATES TO ZERO ***
      VNLQI=0.
      VNLQO=0.
C *** FOR EACH NODE I ON THE LEAKAGE BOUNDARY: ***
      DO 90 I=1,NNDS
C *** (1) DETERMINE FUNCTION TYPE BY SIGN OF E(I) ***
      IF(E(I)) 10,90,40
C ***
C *** DISCHARGE-ONLY TYPE ***
   10 EI=-E(I)
C *** (2) REPRESENT HEADS AND ELEVATIONS BY TEMPORARY (UNSUBSCRIPTED)
C         VARIABLES ***
      ZE=HS(I)
      ZT=TOP(I)
      HI=H(I)
C *** (3) COMPARE HEADS WITH CONTROLLING ELEVATIONS TO IDENTIFY
C         LEAKAGE CASE. COMPUTE HEAD DIFFERENCE, TMPA, FOR VOLUMETRIC-
C         FLOW RATES FOR: ***
      IF(HI.GT.ZE) GO TO 20
C *** CASE (7) (NO FORMULATION) ***
      GO TO 90
   20 IF(HI.LT.ZT) GO TO 30
C *** CASE (1) ***
      TMPA=ZE-ZT
      GO TO 60
C *** CASE (4) ***
   30 TMPA=ZE-HI
      GO TO 60
C ***
C *** STEADY VERTICAL-LEAKAGE TYPE ***
   40 EI=E(I)
C *** (2) REPRESENT HEADS AND ELEVATIONS BY TEMPORARY (UNSUBSCRIPTED)
C         VARIABLES ***
      HA=HS(I)
      ZT=TOP(I)
      HI=H(I)
C *** (3) COMPARE HEAD WITH AQUIFER TOP TO IDENTIFY LEAKAGE CASE.
C         COMPARE HEAD DIFFERENCE, TMPA, FOR VOLUMETRIC-FLOW RATES
C         FOR: ***
      IF(HI.GT.ZT) GO TO 50
C *** CASE (4) ***
      TMPA=HA-ZT
      GO TO 60
C *** CASE (1) ***
   50 TMPA=HA-HI
C ***
C *** (4) COMPUTE VOLUMETRIC-FLOW RATE ***
   60 TMPB=EI*TMPA
C *** (5) SUM VOLUMETRIC-FLOW RATES ACCORDING TO SIGN, POSITIVE
C         FOR INFLOW ***
      IF(TMPB.LT.0.) GO TO 70
      VNLQI=VNLQI+TMPB
      GO TO 80
   70 VNLQO=VNLQO+TMPB
C *** (6) INCLUDE VOLUMETRIC-FLOW RATE INTO FLOW-BALANCE EQUATION AT
C         SPECIFIED-HEAD NODE ***
   80 K=-IN(I)
      IF(K.GT.0) R(K)=R(K)-TMPB
   90 CONTINUE
C *** COMPUTE TOTAL VOLUMES RECHARGED (+) AND DISCHARGED (-) ACROSS
C     BOUNDARY FOR SIMULATION ***
      TNLQI=TNLQI+VNLQI*DT
      TNLQO=TNLQO+VNLQO*DT
C *** INCLUDE VOLUMETRIC-FLOW RATES IN THE FLOW IMBALANCE ***
      ER=ER-VNLQI-VNLQO
      RETURN
      END
