


      SUBROUTINE VNCORR(H,DH,A,B,TOP,E,HS,IN)
C        FORMS COEFFICIENTS FOR NONLINEAR STEADY-LEAKAGE FUNCTIONS;
C        ADDS TERMS TO MATRIX EQUATION FOR THE CORRECTOR
      DIMENSION H(1),DH(1),A(1),B(1),TOP(1),E(1),HS(1)
      DIMENSION IN(1)
      COMMON/NO/NELS,NNDS,NSTEPS,NPER,NZNS,NWELS,NQBND,NHDS,NEQ,MBWC,MBW
      NME=1
C *** COMPUTE WEIGHTING FACTORS FOR GALERKIN-IN-TIME FORMULATION ***
      CA=1./3.
      CB=2./3.
C *** FOR EACH NODE I ON THE LEAKAGE BOUNDARY: ***
      DO 140 I=1,NEQ
      K=IN(I)
C *** (1) BYPASS SPECIFIED-HEAD NODES ***
      IF(K.LT.0) GO TO 140
C *** (2) COMPUTE HEAD AT N LEVEL, HO, CHANGE IN HEAD, DHP, AND
C         PREDICTED HEAD, HP ***
      HO=H(I)-DH(K)
      DHP=1.5*DH(K)
      HP=HO+DHP
C *** (3) DETERMINE FUNCTION TYPE BY SIGN OF E(I) ***
      IF(E(I)) 10,135,90
C ***
C *** DISCHARGE-ONLY TYPE ***
   10 EI=-E(I)
C *** (4) REPRESENT ELEVATIONS, AND HEAD AND ELEVATION DIFFERENCES, BY
C         TEMPORARY (UNSUBSCRIPTED) VARIABLES ***
      ZE=HS(I)
      ZT=TOP(I)
      DEH=ZE-HO
      DHT=HO-ZT
      DET=ZE-ZT
C *** (5) COMPARE HEADS WITH CONTROLLING ELEVATIONS TO IDENTIFY LEAKAGE
C         CASE. ADD LEAKAGE COEFFICIENT TO MAIN DIAGONAL, IF
C         APPLICABLE, AND COMPUTE HEAD DIFFERENCE, TMPA, FOR RIGHT-SIDE
C         TERM FOR: ***
      IF(HO.GT.ZE) GO TO 30
      IF(HP.LT.ZE) GO TO 135
      IF(HP.LT.ZT) GO TO 20
C *** CASE (9) ***
      DMHT=DEH-DHT
      PHCF=1.-CA*(DMHT*DMHT+DHT*DEH)/(DHP*DHP)
      TMPA=PHCF*DET
      GO TO 130
C *** CASE (6) ***
   20 PHC=1.-DEH/DHP
      A(NME)=A(NME)+PHC*EI
      TMPA=CB*PHC*(ZE-HP)
      GO TO 130
   30 IF(HO.LT.ZT) GO TO 40
      IF(HP.LT.ZT) GO TO 70
C *** CASE (1) ***
      TMPA=DET
      GO TO 130
   40 IF(HP.GT.ZT) GO TO 60
      IF(HP.GT.ZE) GO TO 50
C *** CASE (5) ***
      PHE=DEH/DHP
      TMPA=CA*PHE*PHE*DEH
      GO TO 130
C *** CASE (4) ***
   50 A(NME)=A(NME)+EI
      TMPA=ZE-H(I)
      GO TO 130
C *** CASE (3) ***
   60 PHT=DHT/DHP
      TMPA=DET-CA*PHT*PHT*DHT
      GO TO 130
   70 IF(HP.GT.ZE) GO TO 80
C *** CASE (8) ***
      DMHT=DEH-DHT
      PHCF=(DMHT*DMHT+DHT*DEH)/(DHP*DHP)
      TMPA=CA*PHCF*DET
      GO TO 130
C *** CASE (2) ***
   80 PHC=1.+DHT/DHP
      A(NME)=A(NME)+PHC*EI
      TMPA=DET-CB*PHC*(HP-ZT)
      GO TO 130
C ***
C *** STEADY VERTICAL-LEAKAGE TYPE ***
   90 EI=E(I)
C *** (4) REPRESENT CONTROLLING HEAD, AQUIFER TOP ELEVATION, AND
C         DIFFERENCES BY TEMPORARY (UNSUBSCRIPTED) VARIABLES ***
      HA=HS(I)
      ZT=TOP(I)
      DHT=HO-ZT
      DAT=HA-ZT
C *** (5) COMPARE HEADS WITH AQUIFER TOP TO IDENTIFY LEAKAGE CASE. ADD
C         LEAKAGE COEFFICIENTS TO MAIN DIAGONAL, IF APPLICABLE, AND
C         COMPUTE HEAD DIFFERENCE, TMPA, FOR RIGHT-SIDE TERM FOR: ***
      IF(HO.LT.ZT) GO TO 110
      IF(HP.LT.ZT) GO TO 100
C *** CASE (1) ***
      A(NME)=A(NME)+EI
      TMPA=HA-H(I)
      GO TO 130
C *** CASE (2) ***
  100 PHI=DHT/DHP
      TMPA=DAT-CA*PHI*PHI*DHT
      GO TO 130
  110 IF(HP.GT.ZT) GO TO 120
C *** CASE (4) ***
      TMPA=DAT
      GO TO 130
C *** CASE (3) ***
  120 PHC=1.+DHT/DHP
      A(NME)=A(NME)+PHC*EI
      TMPA=DAT-CB*PHC*(HP-ZT)
C ***
C *** (6) COMPUTE RIGHT-SIDE TERM AND ADD TO B-VECTOR FOR BOTH TYPES OF
C         NONLINEAR STEADY-LEAKAGE FUNCTIONS ***
  130 B(K)=B(K)+EI*TMPA
  135 NME=NME+MBWC
  140 CONTINUE
      RETURN
      END
